typedef union {
  int i;
  ExprPtr e;
} YYSTYPE;

#ifndef YYLTYPE
typedef
  struct yyltype
    {
      int timestamp;
      int first_line;
      int first_column;
      int last_line;
      int last_column;
      char *text;
   }
  yyltype;

#define YYLTYPE yyltype
#endif

#define	kw_abstype	257
#define	kw_all	258
#define	kw_and	259
#define	kw_andalso	260
#define	kw_as	261
#define	kw_case	262
#define	kw_do	263
#define	kw_datatype	264
#define	kw_else	265
#define	kw_end	266
#define	kw_exception	267
#define	kw_exists	268
#define	kw_fn	269
#define	kw_fun	270
#define	kw_handle	271
#define	kw_if	272
#define	kw_in	273
#define	kw_in_list	274
#define	kw_in_map	275
#define	kw_in_set	276
#define	kw_infix	277
#define	kw_infixr	278
#define	kw_let	279
#define	kw_local	280
#define	kw_nonfix	281
#define	kw_of	282
#define	kw_orelse	283
#define	kw_dimension	284
#define	kw_raise	285
#define	kw_rec	286
#define	kw_some	287
#define	kw_such_that	288
#define	kw_then	289
#define	kw_type	290
#define	kw_scale	291
#define	kw_val	292
#define	kw_with	293
#define	kw_withtype	294
#define	kw_while	295
#define	kw_open_paren	296
#define	kw_close_paren	297
#define	kw_open_bracket	298
#define	kw_close_bracket	299
#define	kw_open_array_ref	300
#define	kw_array_assign	301
#define	kw_open_brace_under	302
#define	kw_open_brace	303
#define	kw_close_brace	304
#define	kw_open_record	305
#define	kw_close_record	306
#define	kw_open_array	307
#define	kw_close_array	308
#define	kw_comma	309
#define	kw_colon	310
#define	kw_semicolon	311
#define	kw_ellipsis	312
#define	kw_underscore	313
#define	kw_vbar	314
#define	kw_vbar_vbar	315
#define	kw_equal	316
#define	kw_big_arrow	317
#define	kw_arrow	318
#define	kw_star	319
#define	precedence_constant	320
#define	string_constant	321
#define	integer_constant	322
#define	real_constant	323
#define	complex_constant	324
#define	hex_integer_constant	325
#define	octal_integer_constant	326
#define	binary_integer_constant	327
#define	kw_identifier	328
#define	kw_cons_id	329
#define	kw_type_variable	330
#define	kw_left_0	331
#define	kw_right_0	332
#define	kw_left_1	333
#define	kw_right_1	334
#define	kw_left_2	335
#define	kw_right_2	336
#define	kw_left_3	337
#define	kw_right_3	338
#define	kw_left_4	339
#define	kw_right_4	340
#define	kw_left_5	341
#define	kw_right_5	342
#define	kw_left_6	343
#define	kw_right_6	344
#define	kw_left_7	345
#define	kw_right_7	346
#define	kw_left_8	347
#define	kw_right_8	348
#define	kw_left_9	349
#define	kw_right_9	350
#define	kw_left_0_constructor	351
#define	kw_right_0_constructor	352
#define	kw_left_1_constructor	353
#define	kw_right_1_constructor	354
#define	kw_left_2_constructor	355
#define	kw_right_2_constructor	356
#define	kw_left_3_constructor	357
#define	kw_right_3_constructor	358
#define	kw_left_4_constructor	359
#define	kw_right_4_constructor	360
#define	kw_left_5_constructor	361
#define	kw_right_5_constructor	362
#define	kw_left_6_constructor	363
#define	kw_right_6_constructor	364
#define	kw_left_7_constructor	365
#define	kw_right_7_constructor	366
#define	kw_left_8_constructor	367
#define	kw_right_8_constructor	368
#define	kw_left_9_constructor	369
#define	kw_right_9_constructor	370
#define	kw_scale_star	371
#define	kw_scale_power	372
#define	kw_union	373
#define	kw_map_arrow	374
#define	kw_iterate	375
#define	kw_eqtype	376
#define	kw_sharp	377
#define	kw_open_mu	378
#define	kw_use	379
#define	kw_pinf	380
#define	kw_minf	381
#define	kw_nan0	382
#define	kw_nan1	383
#define	kw_nan2	384
#define	kw_nan3	385
#define	kw_nan4	386
#define	kw_nan5	387
#define	kw_nan6	388
#define	kw_nan7	389
#define	kw_mnan1	390
#define	kw_mnan2	391
#define	kw_mnan3	392
#define	kw_mnan4	393
#define	kw_mnan5	394
#define	kw_mnan6	395
#define	kw_mnan7	396
#define	kw_sub_map	397
#define	kw_delay	398
#define	kw_pack	399
#define	kw_memo_fn	400
#define	kw_memo_fun	401
#define	kw_extern	402
#define	kw_pragma	403
#define	kw_sig	404
#define	kw_signature	405
#define	kw_structure	406
#define	kw_sharing	407
#define	kw_open	408
#define	kw_openx	409
#define	kw_include	410
#define	kw_functor	411
#define	kw_abstraction	412
#define	kw_struct	413
#define	kw_compile	414


extern YYSTYPE yylval;
