/* Auxiliary function to build file zinterp.c (unused yet).
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>
#include "portable.h"

main()
{
  FILE *f;
  int i,j;

  f = fopen("zinterp.c","w");
  if (f==NULL)
    {
      fprintf(stderr,"Cannot open file 'zinterp.c' for writing.\n");
      exit(10);
    }
  for (i=0; i<MAX_ARITY; i++)
    {
      fprintf(f,"case %d:\n  return Interpret((bFunPtr)params[0]",i);
      for (j=0; j<i; j++)
	{
	  fprintf(f,",params[%d]",j+1);
	  if ((j & 3)==3)
	    fprintf(f,"\n        ");
	}
      fprintf(f,");\n");
    }
  fclose(f);
  exit(0);
}
