
datatype term = VAR of string
  | INT of int
  | APP of string * term list

val |[put=oput, ...]| = stdout;

fun ppl l =
    iterate
      print stdout (pack (t : term))
    | t in list l
    end;

fun ppatom (VAR x) = oput x
  | ppatom (APP ("prop", VAR p::l)) =
    (oput p; oput " "; ppl l)
  | ppatom (APP ("not", [F])) = (oput "!"; ppatom F)
  | ppatom (APP ("E", [F])) = (oput "*E "; ppatom F)
  | ppatom (APP ("A", [F])) = (oput "*A "; ppatom F)
  | ppatom (APP ("F", [F])) = (oput "*F "; ppatom F)
  | ppatom (APP ("G", [F])) = (oput "*G "; ppatom F)
  | ppatom (APP ("P", [F])) = (oput "*P "; ppatom F)
  | ppatom (APP ("Q", [F])) = (oput "*Q "; ppatom F)
  | ppatom (APP ("and", nil)) = oput "true"
  | ppatom (APP ("or", nil)) = oput "false"
  | ppatom F = (oput "("; oput ")");

ppatom (APP ("A", [APP ("G", [APP ("implies", nil)])]));
