typedef signed char __int8_t;
typedef unsigned char __uint8_t;
typedef short __int16_t;
typedef unsigned short __uint16_t;
typedef int __int32_t;
typedef unsigned int __uint32_t;
typedef long long __int64_t;
typedef unsigned long long __uint64_t;
typedef long __darwin_intptr_t;
typedef unsigned int __darwin_natural_t;
typedef int __darwin_ct_rune_t;
typedef union {
 char __mbstate8[128];
 long long _mbstateL;
} __mbstate_t;
typedef __mbstate_t __darwin_mbstate_t;
typedef long int __darwin_ptrdiff_t;
typedef long unsigned int __darwin_size_t;
typedef __builtin_va_list __darwin_va_list;
typedef int __darwin_wchar_t;
typedef __darwin_wchar_t __darwin_rune_t;
typedef int __darwin_wint_t;
typedef unsigned long __darwin_clock_t;
typedef __uint32_t __darwin_socklen_t;
typedef long __darwin_ssize_t;
typedef long __darwin_time_t;
struct __darwin_pthread_handler_rec
{
 void (*__routine)(void *);
 void *__arg;
 struct __darwin_pthread_handler_rec *__next;
};
struct _opaque_pthread_attr_t { long __sig; char __opaque[56]; };
struct _opaque_pthread_cond_t { long __sig; char __opaque[40]; };
struct _opaque_pthread_condattr_t { long __sig; char __opaque[8]; };
struct _opaque_pthread_mutex_t { long __sig; char __opaque[56]; };
struct _opaque_pthread_mutexattr_t { long __sig; char __opaque[8]; };
struct _opaque_pthread_once_t { long __sig; char __opaque[8]; };
struct _opaque_pthread_rwlock_t { long __sig; char __opaque[192]; };
struct _opaque_pthread_rwlockattr_t { long __sig; char __opaque[16]; };
struct _opaque_pthread_t { long __sig; struct __darwin_pthread_handler_rec *__cleanup_stack; char __opaque[1168]; };
typedef __int64_t __darwin_blkcnt_t;
typedef __int32_t __darwin_blksize_t;
typedef __int32_t __darwin_dev_t;
typedef unsigned int __darwin_fsblkcnt_t;
typedef unsigned int __darwin_fsfilcnt_t;
typedef __uint32_t __darwin_gid_t;
typedef __uint32_t __darwin_id_t;
typedef __uint64_t __darwin_ino64_t;
typedef __darwin_ino64_t __darwin_ino_t;
typedef __darwin_natural_t __darwin_mach_port_name_t;
typedef __darwin_mach_port_name_t __darwin_mach_port_t;
typedef __uint16_t __darwin_mode_t;
typedef __int64_t __darwin_off_t;
typedef __int32_t __darwin_pid_t;
typedef struct _opaque_pthread_attr_t
   __darwin_pthread_attr_t;
typedef struct _opaque_pthread_cond_t
   __darwin_pthread_cond_t;
typedef struct _opaque_pthread_condattr_t
   __darwin_pthread_condattr_t;
typedef unsigned long __darwin_pthread_key_t;
typedef struct _opaque_pthread_mutex_t
   __darwin_pthread_mutex_t;
typedef struct _opaque_pthread_mutexattr_t
   __darwin_pthread_mutexattr_t;
typedef struct _opaque_pthread_once_t
   __darwin_pthread_once_t;
typedef struct _opaque_pthread_rwlock_t
   __darwin_pthread_rwlock_t;
typedef struct _opaque_pthread_rwlockattr_t
   __darwin_pthread_rwlockattr_t;
typedef struct _opaque_pthread_t
   *__darwin_pthread_t;
typedef __uint32_t __darwin_sigset_t;
typedef __int32_t __darwin_suseconds_t;
typedef __uint32_t __darwin_uid_t;
typedef __uint32_t __darwin_useconds_t;
typedef unsigned char __darwin_uuid_t[16];
typedef char __darwin_uuid_string_t[37];
typedef int __darwin_nl_item;
typedef int __darwin_wctrans_t;
typedef __uint32_t __darwin_wctype_t;
typedef __darwin_va_list va_list;
typedef __darwin_size_t size_t;

typedef __darwin_off_t fpos_t;
struct __sbuf {
 unsigned char *_base;
 int _size;
};
struct __sFILEX;
typedef struct __sFILE {
 unsigned char *_p;
 int _r;
 int _w;
 short _flags;
 short _file;
 struct __sbuf _bf;
 int _lbfsize;
 void *_cookie;
 int (*_close)(void *);
 int (*_read) (void *, char *, int);
 fpos_t (*_seek) (void *, fpos_t, int);
 int (*_write)(void *, const char *, int);
 struct __sbuf _ub;
 struct __sFILEX *_extra;
 int _ur;
 unsigned char _ubuf[3];
 unsigned char _nbuf[1];
 struct __sbuf _lb;
 int _blksize;
 fpos_t _offset;
} FILE;

extern FILE *__stdinp;
extern FILE *__stdoutp;
extern FILE *__stderrp;


void clearerr(FILE *);
int fclose(FILE *);
int feof(FILE *);
int ferror(FILE *);
int fflush(FILE *);
int fgetc(FILE *);
int fgetpos(FILE * , fpos_t *);
char *fgets(char * , int, FILE *);
FILE *fopen(const char * , const char * ) __asm("_" "fopen" );
int fprintf(FILE * , const char * , ...) __attribute__((__format__ (__printf__, 2, 3)));
int fputc(int, FILE *);
int fputs(const char * , FILE * ) __asm("_" "fputs" );
size_t fread(void * , size_t, size_t, FILE * );
FILE *freopen(const char * , const char * ,
                 FILE * ) __asm("_" "freopen" );
int fscanf(FILE * , const char * , ...) __attribute__((__format__ (__scanf__, 2, 3)));
int fseek(FILE *, long, int);
int fsetpos(FILE *, const fpos_t *);
long ftell(FILE *);
size_t fwrite(const void * , size_t, size_t, FILE * ) __asm("_" "fwrite" );
int getc(FILE *);
int getchar(void);
char *gets(char *);
void perror(const char *);
int printf(const char * , ...) __attribute__((__format__ (__printf__, 1, 2)));
int putc(int, FILE *);
int putchar(int);
int puts(const char *);
int remove(const char *);
int rename (const char *, const char *);
void rewind(FILE *);
int scanf(const char * , ...) __attribute__((__format__ (__scanf__, 1, 2)));
void setbuf(FILE * , char * );
int setvbuf(FILE * , char * , int, size_t);
int sprintf(char * , const char * , ...) __attribute__((__format__ (__printf__, 2, 3)));
int sscanf(const char * , const char * , ...) __attribute__((__format__ (__scanf__, 2, 3)));
FILE *tmpfile(void);
char *tmpnam(char *);
int ungetc(int, FILE *);
int vfprintf(FILE * , const char * , va_list) __attribute__((__format__ (__printf__, 2, 0)));
int vprintf(const char * , va_list) __attribute__((__format__ (__printf__, 1, 0)));
int vsprintf(char * , const char * , va_list) __attribute__((__format__ (__printf__, 2, 0)));


char *ctermid(char *);
FILE *fdopen(int, const char *) __asm("_" "fdopen" );
int fileno(FILE *);


int pclose(FILE *);
FILE *popen(const char *, const char *) __asm("_" "popen" );


int __srget(FILE *);
int __svfscanf(FILE *, const char *, va_list) __attribute__((__format__ (__scanf__, 2, 0)));
int __swbuf(int, FILE *);

static __inline int __sputc(int _c, FILE *_p) {
 if (--_p->_w >= 0 || (_p->_w >= _p->_lbfsize && (char)_c != '\n'))
  return (*_p->_p++ = _c);
 else
  return (__swbuf(_c, _p));
}

void flockfile(FILE *);
int ftrylockfile(FILE *);
void funlockfile(FILE *);
int getc_unlocked(FILE *);
int getchar_unlocked(void);
int putc_unlocked(int, FILE *);
int putchar_unlocked(int);
int getw(FILE *);
int putw(int, FILE *);
char *tempnam(const char *, const char *) __asm("_" "tempnam" );

typedef __darwin_off_t off_t;

int fseeko(FILE *, off_t, int);
off_t ftello(FILE *);


int snprintf(char * , size_t, const char * , ...) __attribute__((__format__ (__printf__, 3, 4)));
int vfscanf(FILE * , const char * , va_list) __attribute__((__format__ (__scanf__, 2, 0)));
int vscanf(const char * , va_list) __attribute__((__format__ (__scanf__, 1, 0)));
int vsnprintf(char * , size_t, const char * , va_list) __attribute__((__format__ (__printf__, 3, 0)));
int vsscanf(const char * , const char * , va_list) __attribute__((__format__ (__scanf__, 2, 0)));

typedef __darwin_ssize_t ssize_t;

int dprintf(int, const char * , ...) __attribute__((__format__ (__printf__, 2, 3))) __attribute__((visibility("default")));
int vdprintf(int, const char * , va_list) __attribute__((__format__ (__printf__, 2, 0))) __attribute__((visibility("default")));
ssize_t getdelim(char ** , size_t * , int, FILE * ) __attribute__((visibility("default")));
ssize_t getline(char ** , size_t * , FILE * ) __attribute__((visibility("default")));


extern const int sys_nerr;
extern const char *const sys_errlist[];
int asprintf(char **, const char *, ...) __attribute__((__format__ (__printf__, 2, 3)));
char *ctermid_r(char *);
char *fgetln(FILE *, size_t *);
const char *fmtcheck(const char *, const char *);
int fpurge(FILE *);
void setbuffer(FILE *, char *, int);
int setlinebuf(FILE *);
int vasprintf(char **, const char *, va_list) __attribute__((__format__ (__printf__, 2, 0)));
FILE *zopen(const char *, const char *, int);
FILE *funopen(const void *,
                 int (*)(void *, char *, int),
                 int (*)(void *, const char *, int),
                 fpos_t (*)(void *, fpos_t, int),
                 int (*)(void *));

extern int __sprintf_chk (char * , int, size_t,
     const char * , ...)
  ;
extern int __snprintf_chk (char * , size_t, int, size_t,
      const char * , ...)
  ;
extern int __vsprintf_chk (char * , int, size_t,
      const char * , va_list)
  ;
extern int __vsnprintf_chk (char * , size_t, int, size_t,
       const char * , va_list)
  ;
typedef enum {
 P_ALL,
 P_PID,
 P_PGID
} idtype_t;
typedef __darwin_pid_t pid_t;
typedef __darwin_id_t id_t;
typedef int sig_atomic_t;
struct __darwin_i386_thread_state
{
    unsigned int __eax;
    unsigned int __ebx;
    unsigned int __ecx;
    unsigned int __edx;
    unsigned int __edi;
    unsigned int __esi;
    unsigned int __ebp;
    unsigned int __esp;
    unsigned int __ss;
    unsigned int __eflags;
    unsigned int __eip;
    unsigned int __cs;
    unsigned int __ds;
    unsigned int __es;
    unsigned int __fs;
    unsigned int __gs;
};
struct __darwin_fp_control
{
    unsigned short __invalid :1,
        __denorm :1,
    __zdiv :1,
    __ovrfl :1,
    __undfl :1,
    __precis :1,
      :2,
    __pc :2,
    __rc :2,
             :1,
      :3;
};
typedef struct __darwin_fp_control __darwin_fp_control_t;
struct __darwin_fp_status
{
    unsigned short __invalid :1,
        __denorm :1,
    __zdiv :1,
    __ovrfl :1,
    __undfl :1,
    __precis :1,
    __stkflt :1,
    __errsumm :1,
    __c0 :1,
    __c1 :1,
    __c2 :1,
    __tos :3,
    __c3 :1,
    __busy :1;
};
typedef struct __darwin_fp_status __darwin_fp_status_t;
struct __darwin_mmst_reg
{
 char __mmst_reg[10];
 char __mmst_rsrv[6];
};
struct __darwin_xmm_reg
{
 char __xmm_reg[16];
};
struct __darwin_i386_float_state
{
 int __fpu_reserved[2];
 struct __darwin_fp_control __fpu_fcw;
 struct __darwin_fp_status __fpu_fsw;
 __uint8_t __fpu_ftw;
 __uint8_t __fpu_rsrv1;
 __uint16_t __fpu_fop;
 __uint32_t __fpu_ip;
 __uint16_t __fpu_cs;
 __uint16_t __fpu_rsrv2;
 __uint32_t __fpu_dp;
 __uint16_t __fpu_ds;
 __uint16_t __fpu_rsrv3;
 __uint32_t __fpu_mxcsr;
 __uint32_t __fpu_mxcsrmask;
 struct __darwin_mmst_reg __fpu_stmm0;
 struct __darwin_mmst_reg __fpu_stmm1;
 struct __darwin_mmst_reg __fpu_stmm2;
 struct __darwin_mmst_reg __fpu_stmm3;
 struct __darwin_mmst_reg __fpu_stmm4;
 struct __darwin_mmst_reg __fpu_stmm5;
 struct __darwin_mmst_reg __fpu_stmm6;
 struct __darwin_mmst_reg __fpu_stmm7;
 struct __darwin_xmm_reg __fpu_xmm0;
 struct __darwin_xmm_reg __fpu_xmm1;
 struct __darwin_xmm_reg __fpu_xmm2;
 struct __darwin_xmm_reg __fpu_xmm3;
 struct __darwin_xmm_reg __fpu_xmm4;
 struct __darwin_xmm_reg __fpu_xmm5;
 struct __darwin_xmm_reg __fpu_xmm6;
 struct __darwin_xmm_reg __fpu_xmm7;
 char __fpu_rsrv4[14*16];
 int __fpu_reserved1;
};
struct __darwin_i386_avx_state
{
 int __fpu_reserved[2];
 struct __darwin_fp_control __fpu_fcw;
 struct __darwin_fp_status __fpu_fsw;
 __uint8_t __fpu_ftw;
 __uint8_t __fpu_rsrv1;
 __uint16_t __fpu_fop;
 __uint32_t __fpu_ip;
 __uint16_t __fpu_cs;
 __uint16_t __fpu_rsrv2;
 __uint32_t __fpu_dp;
 __uint16_t __fpu_ds;
 __uint16_t __fpu_rsrv3;
 __uint32_t __fpu_mxcsr;
 __uint32_t __fpu_mxcsrmask;
 struct __darwin_mmst_reg __fpu_stmm0;
 struct __darwin_mmst_reg __fpu_stmm1;
 struct __darwin_mmst_reg __fpu_stmm2;
 struct __darwin_mmst_reg __fpu_stmm3;
 struct __darwin_mmst_reg __fpu_stmm4;
 struct __darwin_mmst_reg __fpu_stmm5;
 struct __darwin_mmst_reg __fpu_stmm6;
 struct __darwin_mmst_reg __fpu_stmm7;
 struct __darwin_xmm_reg __fpu_xmm0;
 struct __darwin_xmm_reg __fpu_xmm1;
 struct __darwin_xmm_reg __fpu_xmm2;
 struct __darwin_xmm_reg __fpu_xmm3;
 struct __darwin_xmm_reg __fpu_xmm4;
 struct __darwin_xmm_reg __fpu_xmm5;
 struct __darwin_xmm_reg __fpu_xmm6;
 struct __darwin_xmm_reg __fpu_xmm7;
 char __fpu_rsrv4[14*16];
 int __fpu_reserved1;
 char __avx_reserved1[64];
 struct __darwin_xmm_reg __fpu_ymmh0;
 struct __darwin_xmm_reg __fpu_ymmh1;
 struct __darwin_xmm_reg __fpu_ymmh2;
 struct __darwin_xmm_reg __fpu_ymmh3;
 struct __darwin_xmm_reg __fpu_ymmh4;
 struct __darwin_xmm_reg __fpu_ymmh5;
 struct __darwin_xmm_reg __fpu_ymmh6;
 struct __darwin_xmm_reg __fpu_ymmh7;
};
struct __darwin_i386_exception_state
{
 __uint16_t __trapno;
 __uint16_t __cpu;
 __uint32_t __err;
 __uint32_t __faultvaddr;
};
struct __darwin_x86_debug_state32
{
 unsigned int __dr0;
 unsigned int __dr1;
 unsigned int __dr2;
 unsigned int __dr3;
 unsigned int __dr4;
 unsigned int __dr5;
 unsigned int __dr6;
 unsigned int __dr7;
};
struct __darwin_x86_thread_state64
{
 __uint64_t __rax;
 __uint64_t __rbx;
 __uint64_t __rcx;
 __uint64_t __rdx;
 __uint64_t __rdi;
 __uint64_t __rsi;
 __uint64_t __rbp;
 __uint64_t __rsp;
 __uint64_t __r8;
 __uint64_t __r9;
 __uint64_t __r10;
 __uint64_t __r11;
 __uint64_t __r12;
 __uint64_t __r13;
 __uint64_t __r14;
 __uint64_t __r15;
 __uint64_t __rip;
 __uint64_t __rflags;
 __uint64_t __cs;
 __uint64_t __fs;
 __uint64_t __gs;
};
struct __darwin_x86_float_state64
{
 int __fpu_reserved[2];
 struct __darwin_fp_control __fpu_fcw;
 struct __darwin_fp_status __fpu_fsw;
 __uint8_t __fpu_ftw;
 __uint8_t __fpu_rsrv1;
 __uint16_t __fpu_fop;
 __uint32_t __fpu_ip;
 __uint16_t __fpu_cs;
 __uint16_t __fpu_rsrv2;
 __uint32_t __fpu_dp;
 __uint16_t __fpu_ds;
 __uint16_t __fpu_rsrv3;
 __uint32_t __fpu_mxcsr;
 __uint32_t __fpu_mxcsrmask;
 struct __darwin_mmst_reg __fpu_stmm0;
 struct __darwin_mmst_reg __fpu_stmm1;
 struct __darwin_mmst_reg __fpu_stmm2;
 struct __darwin_mmst_reg __fpu_stmm3;
 struct __darwin_mmst_reg __fpu_stmm4;
 struct __darwin_mmst_reg __fpu_stmm5;
 struct __darwin_mmst_reg __fpu_stmm6;
 struct __darwin_mmst_reg __fpu_stmm7;
 struct __darwin_xmm_reg __fpu_xmm0;
 struct __darwin_xmm_reg __fpu_xmm1;
 struct __darwin_xmm_reg __fpu_xmm2;
 struct __darwin_xmm_reg __fpu_xmm3;
 struct __darwin_xmm_reg __fpu_xmm4;
 struct __darwin_xmm_reg __fpu_xmm5;
 struct __darwin_xmm_reg __fpu_xmm6;
 struct __darwin_xmm_reg __fpu_xmm7;
 struct __darwin_xmm_reg __fpu_xmm8;
 struct __darwin_xmm_reg __fpu_xmm9;
 struct __darwin_xmm_reg __fpu_xmm10;
 struct __darwin_xmm_reg __fpu_xmm11;
 struct __darwin_xmm_reg __fpu_xmm12;
 struct __darwin_xmm_reg __fpu_xmm13;
 struct __darwin_xmm_reg __fpu_xmm14;
 struct __darwin_xmm_reg __fpu_xmm15;
 char __fpu_rsrv4[6*16];
 int __fpu_reserved1;
};
struct __darwin_x86_avx_state64
{
 int __fpu_reserved[2];
 struct __darwin_fp_control __fpu_fcw;
 struct __darwin_fp_status __fpu_fsw;
 __uint8_t __fpu_ftw;
 __uint8_t __fpu_rsrv1;
 __uint16_t __fpu_fop;
 __uint32_t __fpu_ip;
 __uint16_t __fpu_cs;
 __uint16_t __fpu_rsrv2;
 __uint32_t __fpu_dp;
 __uint16_t __fpu_ds;
 __uint16_t __fpu_rsrv3;
 __uint32_t __fpu_mxcsr;
 __uint32_t __fpu_mxcsrmask;
 struct __darwin_mmst_reg __fpu_stmm0;
 struct __darwin_mmst_reg __fpu_stmm1;
 struct __darwin_mmst_reg __fpu_stmm2;
 struct __darwin_mmst_reg __fpu_stmm3;
 struct __darwin_mmst_reg __fpu_stmm4;
 struct __darwin_mmst_reg __fpu_stmm5;
 struct __darwin_mmst_reg __fpu_stmm6;
 struct __darwin_mmst_reg __fpu_stmm7;
 struct __darwin_xmm_reg __fpu_xmm0;
 struct __darwin_xmm_reg __fpu_xmm1;
 struct __darwin_xmm_reg __fpu_xmm2;
 struct __darwin_xmm_reg __fpu_xmm3;
 struct __darwin_xmm_reg __fpu_xmm4;
 struct __darwin_xmm_reg __fpu_xmm5;
 struct __darwin_xmm_reg __fpu_xmm6;
 struct __darwin_xmm_reg __fpu_xmm7;
 struct __darwin_xmm_reg __fpu_xmm8;
 struct __darwin_xmm_reg __fpu_xmm9;
 struct __darwin_xmm_reg __fpu_xmm10;
 struct __darwin_xmm_reg __fpu_xmm11;
 struct __darwin_xmm_reg __fpu_xmm12;
 struct __darwin_xmm_reg __fpu_xmm13;
 struct __darwin_xmm_reg __fpu_xmm14;
 struct __darwin_xmm_reg __fpu_xmm15;
 char __fpu_rsrv4[6*16];
 int __fpu_reserved1;
 char __avx_reserved1[64];
 struct __darwin_xmm_reg __fpu_ymmh0;
 struct __darwin_xmm_reg __fpu_ymmh1;
 struct __darwin_xmm_reg __fpu_ymmh2;
 struct __darwin_xmm_reg __fpu_ymmh3;
 struct __darwin_xmm_reg __fpu_ymmh4;
 struct __darwin_xmm_reg __fpu_ymmh5;
 struct __darwin_xmm_reg __fpu_ymmh6;
 struct __darwin_xmm_reg __fpu_ymmh7;
 struct __darwin_xmm_reg __fpu_ymmh8;
 struct __darwin_xmm_reg __fpu_ymmh9;
 struct __darwin_xmm_reg __fpu_ymmh10;
 struct __darwin_xmm_reg __fpu_ymmh11;
 struct __darwin_xmm_reg __fpu_ymmh12;
 struct __darwin_xmm_reg __fpu_ymmh13;
 struct __darwin_xmm_reg __fpu_ymmh14;
 struct __darwin_xmm_reg __fpu_ymmh15;
};
struct __darwin_x86_exception_state64
{
    __uint16_t __trapno;
    __uint16_t __cpu;
    __uint32_t __err;
    __uint64_t __faultvaddr;
};
struct __darwin_x86_debug_state64
{
 __uint64_t __dr0;
 __uint64_t __dr1;
 __uint64_t __dr2;
 __uint64_t __dr3;
 __uint64_t __dr4;
 __uint64_t __dr5;
 __uint64_t __dr6;
 __uint64_t __dr7;
};
struct __darwin_mcontext32
{
 struct __darwin_i386_exception_state __es;
 struct __darwin_i386_thread_state __ss;
 struct __darwin_i386_float_state __fs;
};
struct __darwin_mcontext_avx32
{
 struct __darwin_i386_exception_state __es;
 struct __darwin_i386_thread_state __ss;
 struct __darwin_i386_avx_state __fs;
};
struct __darwin_mcontext64
{
 struct __darwin_x86_exception_state64 __es;
 struct __darwin_x86_thread_state64 __ss;
 struct __darwin_x86_float_state64 __fs;
};
struct __darwin_mcontext_avx64
{
 struct __darwin_x86_exception_state64 __es;
 struct __darwin_x86_thread_state64 __ss;
 struct __darwin_x86_avx_state64 __fs;
};
typedef struct __darwin_mcontext64 *mcontext_t;
struct __darwin_sigaltstack
{
 void *ss_sp;
 __darwin_size_t ss_size;
 int ss_flags;
};
struct __darwin_ucontext
{
 int uc_onstack;
 __darwin_sigset_t uc_sigmask;
 struct __darwin_sigaltstack uc_stack;
 struct __darwin_ucontext *uc_link;
 __darwin_size_t uc_mcsize;
 struct __darwin_mcontext64 *uc_mcontext;
};
typedef struct __darwin_sigaltstack stack_t;
typedef struct __darwin_ucontext ucontext_t;
typedef __darwin_pthread_attr_t pthread_attr_t;
typedef __darwin_sigset_t sigset_t;
typedef __darwin_uid_t uid_t;
union sigval {
 int sival_int;
 void *sival_ptr;
};
struct sigevent {
 int sigev_notify;
 int sigev_signo;
 union sigval sigev_value;
 void (*sigev_notify_function)(union sigval);
 pthread_attr_t *sigev_notify_attributes;
};
typedef struct __siginfo {
 int si_signo;
 int si_errno;
 int si_code;
 pid_t si_pid;
 uid_t si_uid;
 int si_status;
 void *si_addr;
 union sigval si_value;
 long si_band;
 unsigned long __pad[7];
} siginfo_t;
union __sigaction_u {
 void (*__sa_handler)(int);
 void (*__sa_sigaction)(int, struct __siginfo *,
         void *);
};
struct __sigaction {
 union __sigaction_u __sigaction_u;
 void (*sa_tramp)(void *, int, int, siginfo_t *, void *);
 sigset_t sa_mask;
 int sa_flags;
};
struct sigaction {
 union __sigaction_u __sigaction_u;
 sigset_t sa_mask;
 int sa_flags;
};
typedef void (*sig_t)(int);
struct sigvec {
 void (*sv_handler)(int);
 int sv_mask;
 int sv_flags;
};
struct sigstack {
 char *ss_sp;
 int ss_onstack;
};

void (*signal(int, void (*)(int)))(int);

struct timeval
{
 __darwin_time_t tv_sec;
 __darwin_suseconds_t tv_usec;
};
typedef __uint64_t rlim_t;
struct rusage {
 struct timeval ru_utime;
 struct timeval ru_stime;
 long ru_maxrss;
 long ru_ixrss;
 long ru_idrss;
 long ru_isrss;
 long ru_minflt;
 long ru_majflt;
 long ru_nswap;
 long ru_inblock;
 long ru_oublock;
 long ru_msgsnd;
 long ru_msgrcv;
 long ru_nsignals;
 long ru_nvcsw;
 long ru_nivcsw;
};
struct rlimit {
 rlim_t rlim_cur;
 rlim_t rlim_max;
};

int getpriority(int, id_t);
int getiopolicy_np(int, int) __attribute__((visibility("default")));
int getrlimit(int, struct rlimit *) __asm("_" "getrlimit" );
int getrusage(int, struct rusage *);
int setpriority(int, id_t, int);
int setiopolicy_np(int, int, int) __attribute__((visibility("default")));
int setrlimit(int, const struct rlimit *) __asm("_" "setrlimit" );

static __inline__
__uint16_t
_OSSwapInt16(
    __uint16_t _data
)
{
    return ((_data << 8) | (_data >> 8));
}
static __inline__
__uint32_t
_OSSwapInt32(
    __uint32_t _data
)
{
    return __builtin_bswap32(_data);
}
static __inline__
__uint64_t
_OSSwapInt64(
    __uint64_t _data
)
{
    return __builtin_bswap64(_data);
}
union wait {
 int w_status;
 struct {
  unsigned int w_Termsig:7,
    w_Coredump:1,
    w_Retcode:8,
    w_Filler:16;
 } w_T;
 struct {
  unsigned int w_Stopval:8,
    w_Stopsig:8,
    w_Filler:16;
 } w_S;
};

pid_t wait(int *) __asm("_" "wait" );
pid_t waitpid(pid_t, int *, int) __asm("_" "waitpid" );
int waitid(idtype_t, id_t, siginfo_t *, int) __asm("_" "waitid" );
pid_t wait3(int *, int, struct rusage *);
pid_t wait4(pid_t, int *, int, struct rusage *);


void *alloca(size_t);

typedef __darwin_ct_rune_t ct_rune_t;
typedef __darwin_rune_t rune_t;
typedef __darwin_wchar_t wchar_t;
typedef struct {
 int quot;
 int rem;
} div_t;
typedef struct {
 long quot;
 long rem;
} ldiv_t;
typedef struct {
 long long quot;
 long long rem;
} lldiv_t;
extern int __mb_cur_max;

void abort(void) __attribute__((__noreturn__));
int abs(int) __attribute__((__const__));
int atexit(void (*)(void));
double atof(const char *);
int atoi(const char *);
long atol(const char *);
long long
  atoll(const char *);
void *bsearch(const void *, const void *, size_t,
     size_t, int (*)(const void *, const void *));
void *calloc(size_t, size_t);
div_t div(int, int) __attribute__((__const__));
void exit(int) __attribute__((__noreturn__));
void free(void *);
char *getenv(const char *);
long labs(long) __attribute__((__const__));
ldiv_t ldiv(long, long) __attribute__((__const__));
long long
  llabs(long long);
lldiv_t lldiv(long long, long long);
void *malloc(size_t);
int mblen(const char *, size_t);
size_t mbstowcs(wchar_t * , const char * , size_t);
int mbtowc(wchar_t * , const char * , size_t);
int posix_memalign(void **, size_t, size_t) __attribute__((visibility("default")));
void qsort(void *, size_t, size_t,
     int (*)(const void *, const void *));
int rand(void);
void *realloc(void *, size_t);
void srand(unsigned);
double strtod(const char *, char **) __asm("_" "strtod" );
float strtof(const char *, char **) __asm("_" "strtof" );
long strtol(const char *, char **, int);
long double
  strtold(const char *, char **) ;
long long
  strtoll(const char *, char **, int);
unsigned long
  strtoul(const char *, char **, int);
unsigned long long
  strtoull(const char *, char **, int);
int system(const char *) __asm("_" "system" );
size_t wcstombs(char * , const wchar_t * , size_t);
int wctomb(char *, wchar_t);
void _Exit(int) __attribute__((__noreturn__));
long a64l(const char *);
double drand48(void);
char *ecvt(double, int, int *, int *);
double erand48(unsigned short[3]);
char *fcvt(double, int, int *, int *);
char *gcvt(double, int, char *);
int getsubopt(char **, char * const *, char **);
int grantpt(int);
char *initstate(unsigned, char *, size_t);
long jrand48(unsigned short[3]);
char *l64a(long);
void lcong48(unsigned short[7]);
long lrand48(void);
char *mktemp(char *);
int mkstemp(char *);
long mrand48(void);
long nrand48(unsigned short[3]);
int posix_openpt(int);
char *ptsname(int);
int putenv(char *) __asm("_" "putenv" );
long random(void);
int rand_r(unsigned *);
char *realpath(const char * , char * ) __asm("_" "realpath" "$DARWIN_EXTSN");
unsigned short
 *seed48(unsigned short[3]);
int setenv(const char *, const char *, int) __asm("_" "setenv" );
void setkey(const char *) __asm("_" "setkey" );
char *setstate(const char *);
void srand48(long);
void srandom(unsigned);
int unlockpt(int);
int unsetenv(const char *) __asm("_" "unsetenv" );
typedef signed char int8_t;
typedef unsigned char u_int8_t;
typedef short int16_t;
typedef unsigned short u_int16_t;
typedef int int32_t;
typedef unsigned int u_int32_t;
typedef long long int64_t;
typedef unsigned long long u_int64_t;
typedef int64_t register_t;
typedef __darwin_intptr_t intptr_t;
typedef unsigned long uintptr_t;
typedef u_int64_t user_addr_t;
typedef u_int64_t user_size_t;
typedef int64_t user_ssize_t;
typedef int64_t user_long_t;
typedef u_int64_t user_ulong_t;
typedef int64_t user_time_t;
typedef int64_t user_off_t;
typedef u_int64_t syscall_arg_t;
typedef __darwin_dev_t dev_t;
typedef __darwin_mode_t mode_t;
u_int32_t
  arc4random(void);
void arc4random_addrandom(unsigned char * , int );
void arc4random_buf(void * , size_t ) __attribute__((visibility("default")));
void arc4random_stir(void);
u_int32_t
  arc4random_uniform(u_int32_t ) __attribute__((visibility("default")));
int atexit_b(void (^)(void)) __attribute__((visibility("default")));
void *bsearch_b(const void *, const void *, size_t,
     size_t, int (^)(const void *, const void *)) __attribute__((visibility("default")));
char *cgetcap(char *, const char *, int);
int cgetclose(void);
int cgetent(char **, char **, const char *);
int cgetfirst(char **, char **);
int cgetmatch(const char *, const char *);
int cgetnext(char **, char **);
int cgetnum(char *, const char *, long *);
int cgetset(const char *);
int cgetstr(char *, const char *, char **);
int cgetustr(char *, const char *, char **);
int daemon(int, int) __asm("_" "daemon" "$1050") __attribute__((deprecated,visibility("default")));
char *devname(dev_t, mode_t);
char *devname_r(dev_t, mode_t, char *buf, int len);
char *getbsize(int *, long *);
int getloadavg(double [], int);
const char
 *getprogname(void);
int heapsort(void *, size_t, size_t,
     int (*)(const void *, const void *));
int heapsort_b(void *, size_t, size_t,
     int (^)(const void *, const void *)) __attribute__((visibility("default")));
int mergesort(void *, size_t, size_t,
     int (*)(const void *, const void *));
int mergesort_b(void *, size_t, size_t,
     int (^)(const void *, const void *)) __attribute__((visibility("default")));
void psort(void *, size_t, size_t,
     int (*)(const void *, const void *)) __attribute__((visibility("default")));
void psort_b(void *, size_t, size_t,
     int (^)(const void *, const void *)) __attribute__((visibility("default")));
void psort_r(void *, size_t, size_t, void *,
     int (*)(void *, const void *, const void *)) __attribute__((visibility("default")));
void qsort_b(void *, size_t, size_t,
     int (^)(const void *, const void *)) __attribute__((visibility("default")));
void qsort_r(void *, size_t, size_t, void *,
     int (*)(void *, const void *, const void *));
int radixsort(const unsigned char **, int, const unsigned char *,
     unsigned);
void setprogname(const char *);
int sradixsort(const unsigned char **, int, const unsigned char *,
     unsigned);
void sranddev(void);
void srandomdev(void);
void *reallocf(void *, size_t);
long long
  strtoq(const char *, char **, int);
unsigned long long
  strtouq(const char *, char **, int);
extern char *suboptarg;
void *valloc(size_t);

typedef enum Boolean { false, true } Boolean;
extern void * alloctmp (long size);
extern void * alloctmp_anchored (long size, char *anchor);
extern void freetmp (void * b);
extern void safememcpy ( void * to, void * from, long size);
extern char *newptr (long size) __attribute__ ((malloc));
extern char *newptr_gc (long size) __attribute__ ((malloc));
extern char *newptr_gc_fail (long size) __attribute__ ((malloc));
extern char *newptr_fail (long size) __attribute__ ((malloc));
extern long currentHeapSize;
extern int classifyD ( double *x);
extern int NaNcodeD ( double *x);
extern void makeNaND ( int i, double *x);
extern double floor (double x);
extern double zero,fhalf;
extern char *message (int n);
extern void bmsg (char *msg,...);
extern void berror (char *msg,...) __attribute__ ((noreturn));
extern void bfatal (char *msg,...) __attribute__ ((noreturn));
typedef int pid_type;
typedef struct hFILE {
  struct hFILE *next;
  unsigned char *dirname;
  unsigned char *filename;
  unsigned char *ptr;
  unsigned char *end;
  int fildesc;
  pid_type pid;
  long pos;
  long realpos;
  int flags;
  unsigned char buf[2048];
} hFILE;
extern hFILE *hfopen ( char *name, char *mode);
extern int hfclose ( hFILE *f);
extern hFILE *hfreopen ( char *filename, char *mode, hFILE *f);
extern int hfsuspend ( hFILE *hf);
extern int hfrevive ( hFILE *hf);
extern int hfflush ( hFILE *f);
extern long hftell ( hFILE *f);
extern int hfseek ( hFILE *f, long offset, int whence);
extern int hfgetc ( hFILE *f);
extern int hfputc ( int c, hFILE *f);
extern int hfputs ( char *s, hFILE *f);
extern int hfprintf ( hFILE *f, char *msg,...);
extern hFILE *hstdin,*hstdout,*hstderr;
extern void InitHIO (void);
extern void EndHIO (void);
extern char *ltoasc ( unsigned long a);
extern char *rtoasc ( double *xp);
extern char *timetoasc (unsigned long t);
extern int hReadNewBufGetcN ( hFILE *f, int n);
extern int hReadNewBufGetc ( hFILE *f);
extern int hWriteNewBufPutc ( int c, hFILE *f);
extern void unlinkbuf ( hFILE *f);
extern void linkbuf ( hFILE *f);
extern int hftruncate ( hFILE *f, long n);
extern int wait_pid (pid_type pid);
extern int hpopen ( char **argv, char *mode, hFILE **hff);
typedef int jmp_buf[((9 * 2) + 3 + 16)];
typedef int sigjmp_buf[((9 * 2) + 3 + 16) + 1];

int setjmp(jmp_buf);
void longjmp(jmp_buf, int);
int _setjmp(jmp_buf);
void _longjmp(jmp_buf, int);
int sigsetjmp(sigjmp_buf, int);
void siglongjmp(sigjmp_buf, int);
void longjmperror(void);

typedef __builtin_va_list __gnuc_va_list;
typedef struct TZone {
  unsigned short line1,line2;
  unsigned short pos1,pos2;
} TZone;
struct build_header {
  unsigned char kind;
  unsigned char mark;
  short type;
  TZone z;
  struct Expression *args;
  char padding[8];
};
typedef enum ExprKind {
           E_FREE, E_NIL, E_INT,
           E_REAL, E_COMPLEX, E_STRING, E_CONS,
           E_EMPTY, E_MAPLET, E_MAP,
           E_TUPLE_0, E_TUPLE_1, E_TUPLE_2, E_TUPLE_GNRL,
           E_PAT_REVTUPLE_2,
           E_PAT_TUPLE_GNRL_CONS, E_PAT_REVTUPLE_GNRL_CONS,
           E_PAT_RECORD_GNRL_CONS, E_PAT_REVRECORD_GNRL_CONS,
           E_PAT_RECORD_MAPADD, E_PAT_CONS,
           E_RECORD_0, E_RECORD_1, E_RECORD_GNRL,
           E_PATCHOICE,
           E_EXCEPTION,
           E_COMPILED_CLOSURE, E_INTERPRETED_CLOSURE, OBSOLETE_E_MEMO_CLOSURE ,
           E_POLYFUN, E_MEMO_FN, E_DATACON,
           E_NUMTYPE, E_TYPEFX, E_QUOTE, E_REF,
           E_DATA, OBSOLETE_E_ARRAY_1 , E_ARRAY_2, E_ARRAY_GNRL,
           E_VARINTRO, E_VARREF, E_DEBUGNAME,
           E_ENV, E_LET,
           E_APPL, E_GOTO, E_TYPE_APPL,
           E_PAT_ANY, E_PAT_AS, E_PAT_CHECK, E_PAT_PACK,
           E_PAT_MAPADD, E_PAT_CARD_EQ, E_PAT_CARD_GEQ,
           E_PAT_REVCONS,
           E_GET, E_SET, E_MAPGET,
           E_TSELECT, E_TSEL1, E_TSEL2, E_TSELGNRL,
           E_RSELECT, E_RSEL1, E_RSELGNRL,
           E_RMU1, E_UNSHARED_RMU1, E_RMUX, E_UNSHARED_RMUX,
           E_IF, E_PROG, E_AND, E_OR,
           E_PROG_OF, E_LIST_OF, E_UNSHARED_LIST_OF, E_SET_OF, E_APPEND_OF,
           E_UNSHARED_APPEND_OF, E_UNION_OF, E_UNION_UNDER_OF, E_INTER_OF,
           E_MAP_OF, E_MAP_UNDER_OF, E_ALL_OF, E_EXISTS_OF, E_SOME_OF, E_UNSHARED_SOME_OF,
           E_PROG_MAP, E_LIST_MAP, E_UNSHARED_LIST_MAP, E_SET_MAP, E_APPEND_MAP,
           E_UNSHARED_APPEND_MAP, E_UNION_MAP, E_UNION_UNDER_MAP, E_INTER_MAP,
           E_MAP_MAP, E_MAP_UNDER_MAP, E_ALL_MAP, E_EXISTS_MAP, E_SOME_MAP, E_UNSHARED_SOME_MAP,
           E_PROG_WHILE, E_LIST_WHILE, E_UNSHARED_LIST_WHILE, E_SET_WHILE, E_APPEND_WHILE,
           E_UNSHARED_APPEND_WHILE, E_UNION_WHILE, E_UNION_UNDER_WHILE, E_INTER_WHILE,
           E_MAP_WHILE, E_MAP_UNDER_WHILE, E_ALL_WHILE, E_EXISTS_WHILE, E_SOME_WHILE,
           E_UNSHARED_SOME_WHILE, E_HANDLE, E_RAISE,
           E_DELAY, E_STACK, E_PACK,
           E_EXTERNAL,
           E_DEBUGZONE, E_DEBUGDECL,
           E_PROFILE,
           E_UNSHARED_CONS,
           E_UNSHARED_TUPLE_1, E_UNSHARED_TUPLE_2, E_UNSHARED_TUPLE_GNRL,
           E_UNSHARED_RECORD_1, E_UNSHARED_RECORD_GNRL,
           E_OVERWRITE, E_UNDERWRITE,
           TYPE_ASSUM_KIND, TYPE_STATE_KIND, COMPILE_ASSUM_KIND, BUILD_HEADER_KIND,
           E_SLOT_BRANCH, E_COUNTED,
           E_EQUAL, E_NEQUAL, E_NOT,
           E_BYTECODE, E_N_APPL, E_N_LAMBDA,
           E_UNUSED
} ExprKind;
typedef void (*printFunc) ( unsigned char *text, int len, char *printdata);
typedef void (*readFunc) ( unsigned char *text, int len, char *readdata);
typedef struct StackChunk {
  struct Expression *protected;
  struct excHandler *excStack;
  struct stackMark *thread;
  char *contents;
  char *top;
  char *alloctmp_blocks;
  long age;
} StackChunk;
typedef struct stackMark {
  char *highMark;
  char *lowMark;
  struct stackMark *prev,*next;
  char *alloctmp_blocks;
  struct Expression *stack;
  jmp_buf topBuf;
} stackMark;
typedef struct Vector {
  int n;
  struct Expression *expr[1];
} Vector,*VecPtr;
typedef enum doExtTag {
  X_MARK,
  X_FREE,
  X_MARKDATA,
  X_SAVE,
} doExtTag;
typedef void (*markAction) ( struct Expression *expr);
typedef struct Expression *(*loadAction) ( struct Expression *sharedref);
typedef struct doExtDesc {
  doExtTag xtag;
  markAction action;
} doExtDesc;
typedef struct extDesc {
  unsigned char *name;
  unsigned char id[4];
  struct extDesc *next;
  unsigned long (*hash) ( char *extdata);
  Boolean (*eq) ( char *ext1, char *ext2);
  void (*print) ( char *ext, printFunc doprint, char *printdata);
  void (*sweep) ( char *extdata, doExtDesc *doext);
  struct Expression *(*load) ( struct extDesc *desc, Boolean shared, struct Expression *sharedref, loadAction load);
} extDesc,*extDescPtr;
typedef struct Expression *(*compiledAction) (struct Expression *env, ...);
typedef struct stackDesc {
  struct gcStackView *stack_frames,*heap_frames;
  jmp_buf buf;
} stackDesc;
typedef struct Expression {
  unsigned char kind;
  unsigned char mark;
  short magic;
  unsigned char filler[4];
  struct Expression *link;
  union e_what {
    struct Int {
      long val;
      struct Expression *next;
    } i;
    struct Str {
      long len;
      unsigned char * text;
    } str;
    struct Pair {
      struct Expression *car,*cdr;
    } pair;
    struct Quote {
      struct Expression *ref;
      long n;
    } quote;
    struct Array {
      struct Expression *shape;
      Vector * val;
    } array;
    struct Var {
      int rank,level;
    } var;
    struct Compiled {
      compiledAction action;
      struct Expression *env;
    } compiled;
    struct Handler {
      struct Expression *eh;
      stackDesc * jb;
    } handler;
    struct Stack {
      StackChunk *chunk;
      stackDesc * jb;
    } stack;
    struct ByteCode {
      struct byteCodeChunk *chunk;
      struct Expression *env;
    } bytecode;
    struct External {
      extDescPtr desc;
      char *data;
    } external;
    double x;
  } what;
} Expression,*ExprPtr;
extern ExprPtr nihil;
extern ExprPtr ProtectedListAgainstGC;
extern ExprPtr ProtectedTable[];
extern ExprPtr *ProtectedTableTop;
extern ExprPtr ProtectedAgainstGC;
typedef struct GCMarker {
  ExprPtr pList;
  ExprPtr *pTop;
} GCMarker;
extern struct Expression *writeBarrier;
extern unsigned char IncRefTable[],DecRefTable[];
extern ExprPtr Protect ( ExprPtr e);
extern void EndProtect (GCMarker *save);
extern ExprPtr getProtectWrapper (void);
extern void setProtectWrapper (ExprPtr wrapper,ExprPtr keep);
extern void EndProtectExcept ( GCMarker *save, ExprPtr expr);
typedef struct gcStackView {
  int n;
  struct gcStackView *next;
  ExprPtr p[1];
} gcStackView;
extern gcStackView *theStackFrames,*theHeapFrames;
extern void GC (void);
extern void GCgrow ( int urgency, ExprPtr tag);
extern ExprPtr Reverse1 ( ExprPtr expr, ExprPtr tail) __attribute__ ((pure));
extern ExprPtr Append1 ( ExprPtr e1, ExprPtr e2) __attribute__ ((pure));
extern ExprPtr Append0 ( ExprPtr e1, ExprPtr e2) __attribute__ ((pure));
extern ExprPtr Append ( ExprPtr e1, ExprPtr e2) __attribute__ ((pure));
extern long ListLength ( ExprPtr list) __attribute__ ((pure));
extern ExprPtr Elems0 ( ExprPtr list) __attribute__ ((pure));
extern ExprPtr Inds0 ( ExprPtr list) __attribute__ ((pure));
extern ExprPtr ListToMap0 ( ExprPtr list) __attribute__ ((pure));
extern ExprPtr Nreverse0 ( ExprPtr list, ExprPtr tail);
extern ExprPtr Nreverse1 ( ExprPtr list, ExprPtr tail);
extern ExprPtr Nappend ( ExprPtr list1, ExprPtr list2);
extern ExprPtr empty_map;
extern ExprPtr MapSingleton ( ExprPtr x, ExprPtr y) __attribute__ ((pure));
extern ExprPtr MapPair ( ExprPtr x1, ExprPtr y1, ExprPtr x2, ExprPtr y2) __attribute__ ((pure));
extern ExprPtr MapGet1 ( ExprPtr elem, ExprPtr map, unsigned long mask, Boolean *found);
extern ExprPtr MapGet ( ExprPtr elem, ExprPtr map, Boolean *found);
extern ExprPtr MapGetMaplet1 ( register ExprPtr elem, register ExprPtr map, register unsigned long mask, Boolean *found);
extern ExprPtr MapGetSure ( ExprPtr elem, ExprPtr map) __attribute__ ((pure));
extern ExprPtr MapPutTrie ( ExprPtr x, ExprPtr y, ExprPtr map0, unsigned long mask) __attribute__ ((pure));
extern ExprPtr MapPutBehindTrie ( ExprPtr x, ExprPtr y, ExprPtr map0, unsigned long mask) __attribute__ ((pure));
extern ExprPtr MapPutMapletTrie ( ExprPtr maplet, ExprPtr map0, register unsigned long mask) __attribute__ ((pure));
extern ExprPtr MapPutMapletBehindTrie ( ExprPtr maplet, ExprPtr map0, register unsigned long mask) __attribute__ ((pure));
extern ExprPtr MapRemoveTrie ( ExprPtr x, ExprPtr map0, unsigned long mask) __attribute__ ((pure));
extern ExprPtr MapPut ( ExprPtr x, ExprPtr y, ExprPtr map) __attribute__ ((pure));
extern ExprPtr MapPutBehind ( ExprPtr x, ExprPtr y, ExprPtr map) __attribute__ ((pure));
extern ExprPtr MapRemove ( ExprPtr x, ExprPtr map) __attribute__ ((pure));
typedef Boolean (*mapSweepFunc) ( ExprPtr elt, ExprPtr val, unsigned char *data);
typedef ExprPtr (*mapCollectFunc) ( ExprPtr elt, ExprPtr val, unsigned char *data);
typedef ExprPtr (*mapFoldFunc) ( ExprPtr elt, ExprPtr val, unsigned char *data);
typedef ExprPtr (*mapFoldOp) ( ExprPtr e1, ExprPtr e2);
extern Boolean MapSweep ( ExprPtr map, mapSweepFunc func, void * data);
extern ExprPtr MapSome ( ExprPtr map, mapSweepFunc func, void * data);
extern ExprPtr MapCollect0 ( ExprPtr map, mapCollectFunc func, void * data);
extern ExprPtr MapCollect ( ExprPtr map, mapCollectFunc func, void * data);
extern ExprPtr MapFold ( ExprPtr map, mapFoldFunc func, void * data, ExprPtr neutral, mapFoldOp op );
extern long MapCard ( ExprPtr map) __attribute__ ((pure));
extern long MapCardDec ( ExprPtr map, long n) __attribute__ ((pure));
extern ExprPtr MapMerge1 ( ExprPtr map1, ExprPtr map2, unsigned long mask) __attribute__ ((pure));
extern ExprPtr MapMerge ( ExprPtr map1, ExprPtr map2) __attribute__ ((pure));
extern ExprPtr MapDomRestrTo1 ( ExprPtr map1, ExprPtr map2, unsigned long mask) __attribute__ ((pure));
extern ExprPtr MapDomRestrBy1 ( ExprPtr map1, ExprPtr map2, unsigned long mask) __attribute__ ((pure));
extern ExprPtr MapRngRestrTo1 ( ExprPtr map1, ExprPtr map2) __attribute__ ((pure));
extern ExprPtr MapRngRestrBy1 ( ExprPtr map1, ExprPtr map2) __attribute__ ((pure));
extern ExprPtr MapDelta1 ( ExprPtr map1, ExprPtr map2, unsigned long mask) __attribute__ ((pure));
extern ExprPtr MapDomRestrTo ( ExprPtr map, ExprPtr s) __attribute__ ((pure));
extern ExprPtr MapDomRestrBy ( ExprPtr map, ExprPtr s) __attribute__ ((pure));
extern ExprPtr MapRngRestrTo ( ExprPtr map, ExprPtr s) __attribute__ ((pure));
extern ExprPtr MapRngRestrBy ( ExprPtr map, ExprPtr s) __attribute__ ((pure));
extern ExprPtr MapInter ( ExprPtr map1, ExprPtr map2) __attribute__ ((pure));
extern ExprPtr MapDelta ( ExprPtr map1, ExprPtr map2) __attribute__ ((pure));
extern ExprPtr MapDom1 ( ExprPtr map) __attribute__ ((pure));
extern ExprPtr Dom ( ExprPtr map) __attribute__ ((pure));
extern ExprPtr Rng0 ( ExprPtr map) __attribute__ ((pure));
extern Boolean MapMemberp ( ExprPtr x, ExprPtr map) __attribute__ ((pure));
extern Boolean MapInterp ( ExprPtr map1, ExprPtr map2) __attribute__ ((pure));
extern Boolean MapIncludedp ( ExprPtr map1, ExprPtr map2) __attribute__ ((pure));
extern Boolean SetIncludedp ( ExprPtr map1, ExprPtr map2) __attribute__ ((pure));
extern ExprPtr ChooseInDom ( ExprPtr map) __attribute__ ((pure));
extern ExprPtr ChooseInRng ( ExprPtr map) __attribute__ ((pure));
extern Boolean Setp ( ExprPtr map) __attribute__ ((pure));
extern ExprPtr MapCompose ( ExprPtr map1, ExprPtr map2) __attribute__ ((pure));
extern ExprPtr MapImage ( ExprPtr map, ExprPtr s) __attribute__ ((pure));
extern void MapSplit ( ExprPtr map, ExprPtr *map1, ExprPtr *map2);
extern Boolean sameDomains ( ExprPtr map1, ExprPtr map2) __attribute__ ((pure));
extern void setMapPut ( ExprPtr x, ExprPtr y, ExprPtr *loc);
extern void setrefMapPut ( ExprPtr x, ExprPtr y, ExprPtr ref);
extern void setcarMapPut ( ExprPtr x, ExprPtr y, ExprPtr pair);
extern void setcdrMapPut ( ExprPtr x, ExprPtr y, ExprPtr pair);
extern void setMapRemove ( ExprPtr x, ExprPtr *map);
extern void setcarMapRemove ( ExprPtr x, ExprPtr pair);
extern void setcdrMapRemove ( ExprPtr x, ExprPtr pair);
extern void setMapMerge ( ExprPtr *loc, ExprPtr map);
extern void setcarMapMerge ( ExprPtr pair, ExprPtr map);
extern void setcdrMapMerge ( ExprPtr pair, ExprPtr map);
extern void setMapDomRestrTo ( ExprPtr *loc, ExprPtr map);
extern void setMapDomRestrBy ( ExprPtr *loc, ExprPtr map);
extern ExprPtr mapStack[];
extern ExprPtr *mapStackTop;
extern ExprPtr MapInverse0 ( ExprPtr map) __attribute__ ((pure));
extern void setNPut1 ( ExprPtr x, ExprPtr y, ExprPtr *locp, unsigned long mask, ExprPtr lastloc);
extern void setNPutBehind1 ( ExprPtr x, ExprPtr y, ExprPtr *locp, unsigned long mask, ExprPtr lastloc);
extern void setNRemove1 ( register ExprPtr x, register ExprPtr *locp, register unsigned long mask, ExprPtr lastloc);
extern ExprPtr NGet1 ( ExprPtr x, ExprPtr y, Boolean *foundp, unsigned long mask);
extern ExprPtr NGetMaplet1 ( ExprPtr x, ExprPtr y, Boolean *foundp, unsigned long mask);
typedef Boolean (*nSweepFunc) (ExprPtr loc,char *data);
extern Boolean NSweep ( ExprPtr loc, nSweepFunc fun, char *data);
typedef ExprPtr (*nCollectFunc) (ExprPtr loc,char *data);
extern ExprPtr NCollect ( ExprPtr loc, nCollectFunc fun, char *data);
extern ExprPtr Ktuple2 ( ExprPtr car, ExprPtr cdr) __attribute__ ((pure));
extern ExprPtr Kons ( ExprPtr car, ExprPtr cdr) __attribute__ ((pure));
extern ExprPtr MapletKons ( ExprPtr car, ExprPtr cdr) __attribute__ ((pure));
extern ExprPtr MapKons ( ExprPtr car, ExprPtr cdr) __attribute__ ((pure));
extern ExprPtr Kcomplex ( ExprPtr car, ExprPtr cdr) __attribute__ ((pure));
extern ExprPtr KtypeAppl ( ExprPtr car, ExprPtr cdr) __attribute__ ((pure));
extern ExprPtr KtypeFx ( ExprPtr car, ExprPtr cdr) __attribute__ ((pure));
extern ExprPtr Krecord1 ( ExprPtr car, ExprPtr cdr) __attribute__ ((pure));
extern ExprPtr Kdata ( short magic, ExprPtr car, ExprPtr cdr) __attribute__ ((pure));
extern ExprPtr Kvar ( ExprKind kind, int counter, int level) __attribute__ ((pure));
extern ExprPtr Kcounted ( ExprKind kind, ExprPtr expr, long n) __attribute__ ((pure));
extern ExprPtr KCOUNTED ( ExprPtr expr, long n) __attribute__ ((pure));
extern ExprPtr Karray ( ExprKind kind, ExprPtr shape, long n, ExprPtr *exprs) __attribute__ ((pure));
extern ExprPtr Kint ( long i) __attribute__ ((pure));
extern ExprPtr Kreal ( double *x) __attribute__ ((pure));
extern ExprPtr Kstring1 ( long len, unsigned char *text, Boolean copy) __attribute__ ((pure));
extern ExprPtr Kstr ( unsigned char *text) __attribute__ ((pure));
extern ExprPtr patany,
  tuple0,record0;
extern ExprPtr Kexternal ( extDescPtr desc, char *data) __attribute__ ((pure));
extern ExprPtr KONS (ExprPtr a,ExprPtr b) __attribute__ ((pure));
extern ExprPtr KINT (long i) __attribute__ ((pure));
extern ExprPtr zzero,one,mone,two,half,zpi,
  pinf,minf,
  izero,ione,itwo;
extern ExprPtr trueValue,falseValue;
typedef enum excTag { X_HANDLER, X_CONT, X_PROF } excTag;
typedef struct excHandler {
  struct excHandler *next;
  excTag tag;
  ExprPtr data;
  ExprPtr code;
  stackDesc jb;
} excHandler;
extern excHandler *excStack;
extern ExprPtr Raise ( ExprPtr exception) __attribute__ ((noreturn));
extern void Toplevel ( ExprPtr errcond) __attribute__ ((noreturn));
extern stackMark *currentThread;
extern char *lowMark;
extern ExprPtr CallCC ( compiledAction action, ExprPtr env, Boolean catchp);
extern void Throw1 ( ExprPtr stack, ExprPtr e, stackDesc *sd) __attribute__ ((noreturn));
extern ExprPtr CGlobals[];
extern Boolean checkTypeTag ( ExprPtr val, ExprPtr type);
typedef struct Bucket {
  struct Bucket *next;
  short firstNewCell;
  short occupancy[5];
  char filler[12];
  Expression cell[512];
  Expression *newcells[512];
} Bucket,*BucketPtr;
extern BucketPtr theBucketList;
extern BucketPtr theHomoBucketList,*endHomoBucketList;
extern BucketPtr theHeteroBucketList,*endHeteroBucketList;
extern ExprPtr *nextHomoExpr,*nextHeteroExpr;
extern ExprPtr *lastHomoExpr,*lastHeteroExpr;
extern BucketPtr currentHomoBucket,currentHeteroBucket;
extern BucketPtr oldHomoBucketList,oldHeteroBucketList;
extern void bumpHomoExpr (void);
extern void bumpHeteroExpr (void);
extern BucketPtr theSlotBucketList;
extern ExprPtr theAvailSlotList;
extern ExprPtr reserveSlot;
typedef struct VecBucket {
  struct VecBucket *next;
  struct VecBucket *contents[1];
} VecBucket,*VecBucketPtr;
extern int VecBucketN[13];
extern VecBucketPtr theVecBucketList[13];
extern VecBucketPtr theAvailVecBuckets[13];
extern long nCells;
typedef char *(*allocFunction) (long size);
extern BucketPtr NewBucket (allocFunction new,Boolean force) __attribute__ ((malloc));
extern BucketPtr NewSlotBucket (allocFunction new) __attribute__ ((malloc));
extern VecBucketPtr NewVecBucket (allocFunction new, long n) __attribute__ ((malloc));
extern void * VecAlloc ( long size) __attribute__ ((malloc));
extern void VecFree ( void * p, long size);
extern char dummy;
extern ExprPtr MakePair ( ExprKind kind, ExprPtr car, ExprPtr cdr) __attribute__ ((malloc));
extern ExprPtr MakeData ( short magic, ExprPtr car, ExprPtr cdr) __attribute__ ((malloc));
extern ExprPtr MakeCounted ( ExprKind kind, ExprPtr expr, long n) __attribute__ ((malloc));
extern ExprPtr MakePolyfun ( short magic, ExprPtr expr, long n) __attribute__ ((malloc));
extern ExprPtr MakePromise ( ExprPtr fun) __attribute__ ((malloc));
extern ExprPtr MakeStack ( stackDesc *jb, StackChunk *chunk) __attribute__ ((malloc));
extern ExprPtr MakeRecord ( ExprKind kind, ExprPtr shape, long n, ExprPtr *exprs) __attribute__ ((malloc));
extern ExprPtr MakeArray (int n,ExprPtr e) __attribute__ ((malloc));
extern ExprPtr ListToArray0 (ExprPtr l) __attribute__ ((malloc));
extern ExprPtr MakeExternal ( extDescPtr desc, char *data) __attribute__ ((malloc));
extern ExprPtr MakeCompiled ( ExprKind kind, compiledAction action, ExprPtr env) __attribute__ ((malloc));
typedef struct field {
  ExprPtr label;
  ExprPtr val;
} field;
extern int CompareStrings ( ExprPtr s1, ExprPtr s2);
extern void sortFieldArray ( int n, field *array);
extern ExprPtr fieldsToShape1 ( int n, int n0, field *array);
extern void fieldsToExprs ( ExprPtr *exprs, field *array, int n);
extern ExprPtr MakeRecordGnrl ( int n, field *array, ExprPtr shape) __attribute__ ((malloc));
extern extDesc *getExtDesc ( unsigned char *id);
extern void registerExtDesc ( extDesc *desc);
extern long idiv (long a,long b);
extern long imod (long a,long b);
extern void mergeFieldLists ( ExprPtr *fields1, ExprPtr *fields2, ExprPtr *newfields, long m, long n, long *np);
extern void dumpShape ( ExprPtr shape, ExprPtr *fields);
extern ExprPtr undumpShape ( ExprPtr *fields, long n);
extern ExprPtr Kmu1 ( ExprPtr rec, ExprPtr modlab, ExprPtr modval);
extern ExprPtr Mu1 ( ExprPtr rec, ExprPtr modlab, ExprPtr modval);
extern ExprPtr KmuGnrl ( ExprPtr rec, ExprPtr mod);
extern ExprPtr MuGnrl ( ExprPtr rec, ExprPtr mod);
extern ExprPtr envCons ( register int n, ExprPtr env);
extern ExprPtr QueueToList ( ExprPtr queue);
extern ExprPtr ListToQueue ( ExprPtr list);
extern Boolean do_initialsubmap ( ExprPtr x, ExprPtr y, unsigned char *_data);
extern ExprPtr datacon_sharedAction ( ExprPtr env, ...);
extern void resetHandlerStack (void);
extern void setHandlerStack ( excHandler *stack);
 void mergeFieldLists(fields1,fields2,newfields,m,n,np)
 register ExprPtr *fields1,*fields2;
 register ExprPtr *newfields;
 register long m,n;
 long *np;
{
  long pos;
  pos = 0;
  if (m==0)
    {
copyrest:
      while (n--!=0)
 {
   *newfields++ = *fields2;
   *fields2++ = (ExprPtr)pos++;
 }
      *np = pos;
      return;
    }
  if (n==0)
    {
      n = m;
      fields2 = fields1;
      goto copyrest;
    }
again:
  if (m==1)
    {
      ExprPtr s1,s2;
      register long i,j,k;
      s1 = *fields1;
      i = n>>1;
      j = 0;
      k = n;
      while (j!=k)
 {
   s2 = fields2[i];
   switch (CompareStrings(s1,s2))
     {
     case -1: k = i; break;
     case 1: j = i+1; break;
     case 0:
       *fields1 = (ExprPtr)-1;
       goto copyrest;
     }
   i = (j+k)>>1;
 }
      for (i=0; i<j; i++)
 {
   *newfields++ = *fields2;
   *fields2++ = (ExprPtr)pos++;
 }
      *newfields++ = *fields1;
      *fields1 = (ExprPtr)pos++;
      for (; i<n; i++)
 {
   *newfields++ = *fields2;
   *fields2++ = (ExprPtr)pos++;
 }
      *np = pos;
      return;
    }
  if (n==1)
    {
      ExprPtr s1,s2;
      register long i,j,k;
      s2 = *fields2;
      i = m>>1;
      j = 0;
      k = m;
      while (j!=k)
 {
   s1 = fields1[i];
   switch (CompareStrings(s2,s1))
     {
     case -1: k = i; break;
     case 1: j = i+1; break;
     case 0:
       for (j=0; j<i; j++)
  {
    *newfields++ = *fields1;
    *fields1++ = (ExprPtr)pos++;
  }
       *newfields++ = s1;
       *fields1++ = (ExprPtr)-1;
       *fields2 = (ExprPtr)pos++;
       for (; ++j<m;)
  {
    *newfields++ = *fields1;
    *fields1++ = (ExprPtr)pos++;
  }
       *np = pos;
       return;
     }
   i = (j+k)>>1;
 }
      for (i=0; i<j; i++)
 {
   *newfields++ = *fields1;
   *fields1++ = (ExprPtr)pos++;
 }
      *newfields++ = *fields2;
      *fields2 = (ExprPtr)pos++;
      for (; i<m; i++)
 {
   *newfields++ = *fields1;
   *fields1++ = (ExprPtr)pos++;
 }
      *np = pos;
      return;
    }
  {
    ExprPtr s1,s2;
    s1 = *fields1;
    s2 = *fields2;
    switch (CompareStrings(s1,s2))
      {
      case -1:
 *newfields++ = s1;
 *fields1++ = (ExprPtr)pos++; m--;
 break;
      case 0:
 *newfields++ = s1;
 *fields1++ = (ExprPtr)-1; m--;
 *fields2++ = (ExprPtr)pos++; n--;
 break;
      case 1:
 *newfields++ = s2;
 *fields2++ = (ExprPtr)pos++; n--;
 break;
      }
  }
  goto again;
}
static Boolean do_dumpshape ( ExprPtr x, ExprPtr y, unsigned char *_data); static Boolean do_dumpshape(x,y,_data) ExprPtr x,y; unsigned char *_data;
{
  ExprPtr *fields;
  fields = ((ExprPtr *)_data);
  fields[(y)->what.i.val-1] = x;
  return false;
}
 void dumpShape(shape,fields)
 ExprPtr shape;
 ExprPtr *fields;
{
  (void) MapSweep(shape,do_dumpshape,fields);
}
static ExprPtr undumpShape1(fields,m,n)
 register ExprPtr *fields;
 register long m,n;
{
  if (n==0)
    return empty_map;
  if (n==1)
    {
      ExprPtr e;
      ;
      e = Kint(m);
      ProtectedAgainstGC = e;
      e = MapletKons(fields[0],e);
      ProtectedAgainstGC = nihil;
      return e;
    }
  {
    struct _x { int n; gcStackView *next; ExprPtr p[2];} _x;
    long nn = n>>1;
    _x.p[0] = undumpShape1(fields,m,nn);
    _x.n = 1;
    _x.next = theStackFrames;
    theStackFrames = (gcStackView *)&_x;
    _x.p[1] = undumpShape1(fields+nn,m+nn,n-nn);
    _x.n = 2;
    _x.p[0] = (_x.p[0]==empty_map)?_x.p[1]:((_x.p[1]==empty_map)?_x.p[0]:(mapStackTop=mapStack, MapMerge1(_x.p[0],_x.p[1],(unsigned long)(1L<<(4)))));
    theStackFrames = _x.next;
    return _x.p[0];
  }
}
 ExprPtr undumpShape(fields,n)
 ExprPtr *fields;
 long n;
{
  ExprPtr shape;
  shape = undumpShape1(fields,(long)1,n);
  (void) ((ProtectedTableTop<ProtectedTable+512)?(*ProtectedTableTop++=(shape)):Protect(shape));
  return shape;
}
 ExprPtr Kmu1(rec,modlab,modval) ExprPtr rec; ExprPtr modlab,modval; { struct GCMarker protectThemAgainstGCs; protectThemAgainstGCs.pList = ProtectedListAgainstGC; protectThemAgainstGCs.pTop = ProtectedTableTop; switch (rec->kind) { case E_RECORD_0: buildmod: if (true) rec = Krecord1(modlab,modval); else { if (nextHomoExpr!=lastHomoExpr) ; else bumpHomoExpr(); rec = *nextHomoExpr++; (rec)->mark = 0; (rec)->link = ((struct Expression *)-1L); (rec)->kind = (unsigned char)E_RECORD_1; (rec)->what.pair.car = modlab; (rec)->what.pair.cdr = modval; } break; case E_RECORD_1: if ((rec)->what.pair.car==modlab) goto buildmod; { ExprPtr shape; ExprPtr exprs[2]; if (CompareStrings((rec)->what.pair.car,modlab)<0) { shape = MapPair((rec)->what.pair.car,ione,modlab,itwo); exprs[0] = (rec)->what.pair.cdr; exprs[1] = modval; } else { shape = MapPair(modlab,ione,(rec)->what.pair.car,itwo); exprs[0] = modval; exprs[1] = (rec)->what.pair.cdr; } rec = true?Karray(E_RECORD_GNRL,shape,2,exprs):MakeRecord(E_RECORD_GNRL,shape,2,exprs); break; } case E_RECORD_GNRL: { ExprPtr shape; long i,n,nn; ExprPtr *ep,*epp; shape = (rec)->what.array.shape; n = (rec)->what.array.val->n; { ExprPtr *fields,*outfields,*exprs; fields = (ExprPtr *)alloctmp((3*n+2)*sizeof(ExprPtr)); outfields = fields + n; exprs = outfields+1+n; dumpShape(shape,fields); mergeFieldLists(fields,&modlab,outfields,n,(long)1,&nn); shape = undumpShape1(outfields,(long)1,nn); (void) ((ProtectedTableTop<ProtectedTable+512)?(*ProtectedTableTop++=(shape)):Protect(shape)); for (i=0, ep=(rec)->what.array.val->expr, epp=exprs; i<(long)modlab; i++) *epp++ = *ep++; *epp++ = modval; i++; if (nn==n) ep++; for (; i<nn; i++) *epp++ = *ep++; rec = true?Karray(E_RECORD_GNRL,shape,nn,exprs):MakeRecord(E_RECORD_GNRL,shape,nn,exprs); } break; } } EndProtect(&protectThemAgainstGCs); return rec; }
 ExprPtr Mu1(rec,modlab,modval) ExprPtr rec; ExprPtr modlab,modval; { struct GCMarker protectThemAgainstGCs; protectThemAgainstGCs.pList = ProtectedListAgainstGC; protectThemAgainstGCs.pTop = ProtectedTableTop; switch (rec->kind) { case E_RECORD_0: buildmod: if (false) rec = Krecord1(modlab,modval); else { if (nextHomoExpr!=lastHomoExpr) ; else bumpHomoExpr(); rec = *nextHomoExpr++; (rec)->mark = 0; (rec)->link = ((struct Expression *)-1L); (rec)->kind = (unsigned char)E_RECORD_1; (rec)->what.pair.car = modlab; (rec)->what.pair.cdr = modval; } break; case E_RECORD_1: if ((rec)->what.pair.car==modlab) goto buildmod; { ExprPtr shape; ExprPtr exprs[2]; if (CompareStrings((rec)->what.pair.car,modlab)<0) { shape = MapPair((rec)->what.pair.car,ione,modlab,itwo); exprs[0] = (rec)->what.pair.cdr; exprs[1] = modval; } else { shape = MapPair(modlab,ione,(rec)->what.pair.car,itwo); exprs[0] = modval; exprs[1] = (rec)->what.pair.cdr; } rec = false?Karray(E_RECORD_GNRL,shape,2,exprs):MakeRecord(E_RECORD_GNRL,shape,2,exprs); break; } case E_RECORD_GNRL: { ExprPtr shape; long i,n,nn; ExprPtr *ep,*epp; shape = (rec)->what.array.shape; n = (rec)->what.array.val->n; { ExprPtr *fields,*outfields,*exprs; fields = (ExprPtr *)alloctmp((3*n+2)*sizeof(ExprPtr)); outfields = fields + n; exprs = outfields+1+n; dumpShape(shape,fields); mergeFieldLists(fields,&modlab,outfields,n,(long)1,&nn); shape = undumpShape1(outfields,(long)1,nn); (void) ((ProtectedTableTop<ProtectedTable+512)?(*ProtectedTableTop++=(shape)):Protect(shape)); for (i=0, ep=(rec)->what.array.val->expr, epp=exprs; i<(long)modlab; i++) *epp++ = *ep++; *epp++ = modval; i++; if (nn==n) ep++; for (; i<nn; i++) *epp++ = *ep++; rec = false?Karray(E_RECORD_GNRL,shape,nn,exprs):MakeRecord(E_RECORD_GNRL,shape,nn,exprs); } break; } } EndProtect(&protectThemAgainstGCs); return rec; }
 ExprPtr KmuGnrl(rec,mod)
 ExprPtr rec; ExprPtr mod; 
{
 struct GCMarker protectThemAgainstGCs;
 protectThemAgainstGCs.pList = ProtectedListAgainstGC;
 protectThemAgainstGCs.pTop = ProtectedTableTop;
 switch (rec->kind) {
 case E_RECORD_0: rec = mod; break;
 case E_RECORD_1: { ExprPtr shape; Boolean found;
 shape = (mod)->what.array.shape; if ((void) MapGet((rec)->what.pair.car,shape,&found), found) rec = mod; else { long i,n,nn; ExprPtr lab; ExprPtr *ep,*epp; n = (mod)->what.array.val->n; { ExprPtr *fields,*outfields,*exprs; fields = (ExprPtr *)alloctmp((3*n+2)*sizeof(ExprPtr)); outfields = fields + n; exprs = outfields+1+n; dumpShape(shape,fields); lab = (rec)->what.pair.car; mergeFieldLists(&lab,fields,outfields,(long)1,n,&nn);
 shape = undumpShape1(outfields,(long)1,nn); (void) ((ProtectedTableTop<ProtectedTable+512)?(*ProtectedTableTop++=(shape)):Protect(shape)); for (i=0, ep=(mod)->what.array.val->expr, epp=exprs; i<(long)lab; i++) *epp++ = *ep++; *epp++ = (rec)->what.pair.cdr; i++; for (; i<nn; i++) *epp++ = *ep++; rec = true?Karray(E_RECORD_GNRL,shape,nn,exprs):MakeRecord(E_RECORD_GNRL,shape,nn,exprs); } } } break;
 case E_RECORD_GNRL: { long i,m,n,nn; ExprPtr shape;
 ExprPtr *ep,*epp,*fp;
 m = (rec)->what.array.val->n;
 n = (mod)->what.array.val->n;
 { ExprPtr *fields1,*fields2,*outfields,*exprs;
 nn = m+n;
 fields1 = (ExprPtr *)alloctmp(nn*(3*sizeof(ExprPtr)));
 fields2 = fields1+m; outfields = fields2+n;
 exprs = outfields+nn; dumpShape((rec)->what.array.shape,fields1);
 dumpShape((mod)->what.array.shape,fields2);
 mergeFieldLists(fields1,fields2,outfields,m,n,&nn); shape = undumpShape1(outfields,(long)1,nn); (void) ((ProtectedTableTop<ProtectedTable+512)?(*ProtectedTableTop++=(shape)):Protect(shape));
 epp = exprs;
 for (i=0, ep=(rec)->what.array.val->expr, fp=fields1; i<m; i++, ep++)
 { int ii;
 ii = (int)*fp++;
 if (ii!=-1) { epp[ii] = *ep; }; }
 for (i=0, ep=(mod)->what.array.val->expr, fp=fields2; i<n; i++, ep++) { { epp[(int)*fp++] = *ep; }; } rec = true?Karray(E_RECORD_GNRL,shape,nn,exprs):MakeRecord(E_RECORD_GNRL,shape,nn,exprs); } break; } }
 EndProtect(&protectThemAgainstGCs); return rec; }
 ExprPtr MuGnrl(rec,mod) ExprPtr rec; ExprPtr mod; { struct GCMarker protectThemAgainstGCs; protectThemAgainstGCs.pList = ProtectedListAgainstGC; protectThemAgainstGCs.pTop = ProtectedTableTop; switch (rec->kind) { case E_RECORD_0: rec = mod; break; case E_RECORD_1: { ExprPtr shape; Boolean found; shape = (mod)->what.array.shape; if ((void) MapGet((rec)->what.pair.car,shape,&found), found) rec = mod; else { long i,n,nn; ExprPtr lab; ExprPtr *ep,*epp; n = (mod)->what.array.val->n; { ExprPtr *fields,*outfields,*exprs; fields = (ExprPtr *)alloctmp((3*n+2)*sizeof(ExprPtr)); outfields = fields + n; exprs = outfields+1+n; dumpShape(shape,fields); lab = (rec)->what.pair.car; mergeFieldLists(&lab,fields,outfields,(long)1,n,&nn); shape = undumpShape1(outfields,(long)1,nn); (void) ((ProtectedTableTop<ProtectedTable+512)?(*ProtectedTableTop++=(shape)):Protect(shape)); for (i=0, ep=(mod)->what.array.val->expr, epp=exprs; i<(long)lab; i++) *epp++ = *ep++; *epp++ = (rec)->what.pair.cdr; i++; for (; i<nn; i++) *epp++ = *ep++; rec = false?Karray(E_RECORD_GNRL,shape,nn,exprs):MakeRecord(E_RECORD_GNRL,shape,nn,exprs); } } } break; case E_RECORD_GNRL: { long i,m,n,nn; ExprPtr shape; ExprPtr *ep,*epp,*fp; m = (rec)->what.array.val->n; n = (mod)->what.array.val->n; { ExprPtr *fields1,*fields2,*outfields,*exprs; nn = m+n; fields1 = (ExprPtr *)alloctmp(nn*(3*sizeof(ExprPtr))); fields2 = fields1+m; outfields = fields2+n; exprs = outfields+nn; dumpShape((rec)->what.array.shape,fields1); dumpShape((mod)->what.array.shape,fields2); mergeFieldLists(fields1,fields2,outfields,m,n,&nn); shape = undumpShape1(outfields,(long)1,nn); (void) ((ProtectedTableTop<ProtectedTable+512)?(*ProtectedTableTop++=(shape)):Protect(shape)); epp = exprs; for (i=0, ep=(rec)->what.array.val->expr, fp=fields1; i<m; i++, ep++) { int ii; ii = (int)*fp++; if (ii!=-1) { epp[ii] = *ep; }; } for (i=0, ep=(mod)->what.array.val->expr, fp=fields2; i<n; i++, ep++) { { epp[(int)*fp++] = *ep; }; } rec = false?Karray(E_RECORD_GNRL,shape,nn,exprs):MakeRecord(E_RECORD_GNRL,shape,nn,exprs); } break; } } EndProtect(&protectThemAgainstGCs); return rec; }
 ExprPtr envCons(n,env)
 register int n;
 ExprPtr env;
{
  VecPtr vp;
  if (nextHeteroExpr!=lastHeteroExpr) ; else bumpHeteroExpr();
  { register long _V_size=((long)(((char *)&((Vector *)0L)->expr[n])-((char *)(Vector *)0L))), _V_n = (_V_size + (sizeof(VecBucketPtr)-1))/sizeof(VecBucketPtr); if (_V_n==0) *(char **)&vp = (void *)&dummy; else if (_V_n>=13) *(char **)&vp = (void *)newptr_gc((long)_V_size); else { register VecBucketPtr *_V_vp = theAvailVecBuckets+_V_n; if (*_V_vp==(VecBucketPtr)0L) (void) NewVecBucket(newptr_gc,_V_n); *(char **)&vp = (void *)*_V_vp; *_V_vp = *(VecBucketPtr *)*_V_vp; } };
  vp->n = n;
  {
    register ExprPtr *ep,*epend;
    for (ep = vp->expr, epend = ep+n; ep<epend; ) *ep++ = (ExprPtr)0L;
  }
  {
    register ExprPtr res;
    res = *nextHeteroExpr++; (res)->mark = 0; (res)->link = ((struct Expression *)-1L); (res)->kind = (unsigned char)E_ENV; (res)->what.array.val = vp; (res)->what.array.shape = env;
    return res;
  }
}
 ExprPtr QueueToList(queue)
 ExprPtr queue;
{
  {
    register ExprPtr e,last,next,fin;
    for (last = nihil, e = fin = (queue)->what.pair.cdr;;)
      {
 next = (e)->what.pair.cdr;
 { (e)->what.pair.cdr = last; {if ((e)->link==((struct Expression *)1L)) { (e)->link=writeBarrier;writeBarrier=(e); }};};
 if (next==fin)
   break;
 last = e;
 e = next;
      }
  }
  return Reverse1(queue,nihil);
}
 ExprPtr ListToQueue(list)
 ExprPtr list;
{
  register ExprPtr e,end,last;
  ;
  if (nextHomoExpr!=lastHomoExpr) ; else bumpHomoExpr(); e = *nextHomoExpr++; (e)->mark = 0; (e)->link = ((struct Expression *)-1L);
  e->kind = (unsigned char)E_CONS;
  (e)->what.pair.car = (list)->what.pair.car;
  (e)->what.pair.cdr = e;
  ProtectedAgainstGC = e;
  end = e;
  for (; last = e, list = (list)->what.pair.cdr, list!=nihil; )
    {
      if (nextHomoExpr!=lastHomoExpr) ; else bumpHomoExpr(); e = *nextHomoExpr++; (e)->mark = 0; (e)->link = ((struct Expression *)-1L);
      e->kind = (unsigned char)E_CONS;
      (e)->what.pair.car = (list)->what.pair.car;
      (e)->what.pair.cdr = end;
      { (last)->what.pair.cdr = e; {if ((last)->link==((struct Expression *)1L)) { (last)->link=writeBarrier;writeBarrier=(last); }};};
    }
  ProtectedAgainstGC = nihil;
  return e;
}
 Boolean do_initialsubmap(x,y,_data)
 ExprPtr x,y;
 unsigned char *_data;
{
  ExprPtr *listp;
  ExprPtr aux,aux2;
  listp = ((ExprPtr *volatile)_data);
  aux = MapletKons(x,y);
  if (nextHomoExpr!=lastHomoExpr) ; else bumpHomoExpr(); aux2 = *nextHomoExpr++; (aux2)->mark = 0; (aux2)->link = ((struct Expression *)-1L); (aux2)->kind = (unsigned char)E_OR; (aux2)->what.pair.car = aux; (aux2)->what.pair.cdr = *listp;
  *listp = aux2;
  return false;
}
 ExprPtr datacon_sharedAction( ExprPtr env, ...) { struct GCMarker protectThemAgainstGCs; protectThemAgainstGCs.pList = ProtectedListAgainstGC; protectThemAgainstGCs.pTop = ProtectedTableTop; va_list _args; ExprPtr arg, res; __builtin_va_start(_args,env); switch ((((unsigned long)(env)) & ((1L<<(4))-1L))) { case 0: arg = tuple0; break; case 1: arg = __builtin_va_arg(_args,ExprPtr); break; case 2: { ExprPtr arg1 = __builtin_va_arg(_args,ExprPtr); ExprPtr arg2 = __builtin_va_arg(_args,ExprPtr); arg = Ktuple2(arg1,arg2); (void) ((ProtectedTableTop<ProtectedTable+512)?(*ProtectedTableTop++=(arg)):Protect(arg)); break; } default: { int i, n = (((unsigned long)(env)) & ((1L<<(4))-1L)); ExprPtr args[((1L<<(4))-1L)+1]; for (i=0; i<n; i++) args[i] = __builtin_va_arg(_args,ExprPtr); arg = Karray(E_TUPLE_GNRL,nihil,n,args); (void) ((ProtectedTableTop<ProtectedTable+512)?(*ProtectedTableTop++=(arg)):Protect(arg)); break; } } __builtin_va_end(_args); {
{
  ExprPtr res;
  ExprPtr uenv;
  uenv = (ExprPtr)(((unsigned long)(env)) & ~((1L<<(4))-1L));
  res = Kdata(uenv->magic, (uenv)->what.pair.car, arg);
  return res;
}
}}
 void resetHandlerStack()
{
  excStack = ((void *)0);
}
 void setHandlerStack(stack)
 excHandler *stack;
{
  excStack = stack;
}
