(* HimML standard archive/link helper.
   Copyright (C) 2002-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*)

(*val |[match, ...]| = regexp ".mlx?$";*)

fun main () =
    let val |[put, flush, ...]| = stdout
    in
	put "(* packed library/bytecode file, generated automatically by himmlpack. *)\n";
	iterate
	  let val file = arg
		  (*case match arg of
			SOME (i, _) => substr (arg, 0, i)
		      | _ => arg
		   *)
	  in
	      (put "open* ";
	       print stdout (pack file);
	       put ";\n")
	  end
	| arg in list args()
	end;
	flush ()
    end;
