/* List of patches, used by makemake.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

#include <stdio.h>

#undef LONGJUMPXFILE
#undef LONGJUMPXPB

#ifdef vax
#ifndef __vax__
#define __vax__
#endif
#endif

#ifdef __vax__
#define LONGJUMPXFILE "vaxjmp.o"
#endif

#ifdef convex
#ifndef __convex__
#define __convex__
#endif
#endif

#ifdef __convex__
#define LONGJUMPXFILE "convexjmp.o"
#ifndef __GNUC__
#define LONGJUMPXPB "You should preferrably use gcc to compile conevxjmp.c, or edit the latter to produce an assembler file to give to as(1) (Then, could you send it to me, goubault@lsv.ens-cachan.fr, so that I can include it in later distributions of HimML? Thanks.)\n"
#endif
#endif

main(argc,argv)
int argc;
char **argv;
{
#ifdef LONGJUMPXPB
  fputs(LONGJUMPXPB,stderr);
  fflush(stderr);
#endif
#ifdef LONGJUMPXFILE
  fputs(LONGJUMPXFILE,stdout);
  fflush(stdout);
#endif
  return 0;
}
