infix 9 sub

datatype peg = Out | Empty | Peg;

val board = arrayoflist [
 arrayoflist [ Out, Out, Out, Out, Out, Out, Out, Out, Out],
 arrayoflist [ Out, Out, Out, Peg, Peg, Peg, Out, Out, Out],
 arrayoflist [ Out, Out, Out, Peg, Peg, Peg, Out, Out, Out],
 arrayoflist [ Out, Peg, Peg, Peg, Peg, Peg, Peg, Peg, Out],
 arrayoflist [ Out, Peg, Peg, Peg, Empty, Peg, Peg, Peg, Out],
 arrayoflist [ Out, Peg, Peg, Peg, Peg, Peg, Peg, Peg, Out],
 arrayoflist [ Out, Out, Out, Peg, Peg, Peg, Out, Out, Out],
 arrayoflist [ Out, Out, Out, Peg, Peg, Peg, Out, Out, Out],
 arrayoflist [ Out, Out, Out, Out, Out, Out, Out, Out, Out]
]
;

val moves = array(31,((arrayoflist []) : num array array));

val dir = arrayoflist [ arrayoflist [0,1], 

                        arrayoflist [1,0],
                        arrayoflist [0,~1],
                        arrayoflist [~1,0] ];

val counter = ref 0;

exception found;

fun incr a = a := 1+ !a;

fun solve m =
 (incr counter;
  if m = 31 then
    case board sub 4 sub 4 of Peg => true | _ => false
  else
     (if !counter mod 500 = 0 then
        (print (stdout,pack !counter); #put stdout "\n") else ();
      let fun loopi i = if i>7 then () else
      let fun loopj j = if j>7 then () else (
        case board sub i sub j of
          Peg =>
            let fun loopk k = if k>3 then () else (
              let val d1 = dir sub k sub 0
                  val d2 = dir sub k sub 1 in
              let val i1 = i+d1 in
              let val i2 = i1+d1 in
              let val j1 = j+d2 in
              let val j2 = j1+d2 in
              case  board sub i1 sub j1 of
                Peg =>
                 (case board sub i2 sub j2 of
                    Empty =>
                     (update(board sub i,j,Empty);
                      update(board sub i1,j1,Empty);
                      update(board sub i2,j2,Peg);
                      if solve(m+1) then
                       (update(moves,m,arrayoflist [ arrayoflist [ i, j ],
                                                     arrayoflist [ i2, j2 ] ]);
                        raise found) else ();
                      update(board sub i,j,Peg);
                      update(board sub i1,j1,Peg);
                      update(board sub i2,j2,Empty);
                      ())
                    | _ => () )
              | _ => ()
                  end end end end end; loopk (k+1)) in loopk 0 end
        | _ => (); loopj (j+1)) in loopj 1; loopi (i+1) end in loopi 1 end;
      false)
    handle found => true)
;

fun print_peg Out = #put stdout "."
  | print_peg Empty = #put stdout " "
  | print_peg Peg = #put stdout "$"
;

fun print_board board =
 (let val i = ref 0 in while !i <= 8 do
 (let val j = ref 0 in while !j <= 8 do
    (print_peg (board sub !i sub !j); incr j) end;
  incr i;#put stdout "\n") end;
 #put stdout "\n")
;

fun main x = (if solve 0 then (#put stdout "\n"; print_board board)
              else #put stdout "Pas trouve"; ())
;

(*
.........
...   ...
...   ...
.       .
.   $   .
.       .
...   ...
...   ...
.........
*)
