/* Stack and continuation handling functions, headers.
   This is mostly black magic.
   Copyright (C) 1992-1997 Jean Goubault-Larrecq and Bull S.A.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

	/*  number of bytes from initial top of stack to ML top of stack:   */
#define TOP_STACK_OFFSET	16
	/*  number of bytes allocated by default to the ML stack:   */
#define STACK_SIZE  10000
	/*  number of bytes above bottom of stack below which the stack
	pointer must not lie (checked by Eval()):   */
#define SAFETY_SIZE 2500

typedef struct stackMark {
  char *highMark;
  char *lowMark;
} stackMark;
