/* Static structures for modules.c.
   Copyright (C) 1992-2000 Jean Goubault-Larrecq and Bull S.A.
   Copyright (C) 2000-2005 Jean Goubault-Larrecq
   and LSV, CNRS UMR 8643 & INRIA Futurs projet Secsi & ENS Cachan.

   This file is part of HimML.

   HimML is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2, or (at your option)
   any later version.

   HimML is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.

   You should have received a copy of the GNU General Public License
   along with HimML; see the file COPYING.  If not, write to
   the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
*/

struct tdgor {
  ExprPtr t1;
  ExprPtr t2;
  Boolean sign1;
  Boolean sign2;
};

struct tdgequiv {
  ExprPtr t1;
  ExprPtr t2;
  Boolean eqv;
};

struct tdginst {
  ExprPtr t;
  ExprPtr subst;
  Boolean defselfp;
};

struct checkcond {
  ExprPtr assum;
  ExprPtr state;
};

struct checkcons {
  ExprPtr assum;
  ExprPtr state;
  MapPtr cons2;
  MapPtr subst1;
  MapPtr subst2;
};

struct occurs2p {
  ExprPtr typevar;
  ExprPtr state;
};

struct occurs2pk {
  ExprPtr typevar;
  ExprPtr type;
  ExprPtr state;
  Boolean res;
};

struct instsig {
  ExprPtr state;
  MapPtr subst; /* for variables in a TDG */
};

struct instassum {
  ExprPtr assum;
  ExprPtr state0;
  MapPtr subst;
};

struct instlist {
  ExprPtr state0;
  MapPtr subst;
  ExprPtr new;
};
