/* static declarations for file compaux.c */
static Boolean optReverse P((ExprPtr *, ExprPtr *, double *, double *));
static Boolean do_typeweight P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_typeweight_num P((ExprPtr, ExprPtr, unsigned char *));
static void typeWeightk P((ExprPtr, double *, double *));
static void typeWeight P((ExprPtr, double *, double *));
static void addTypeWeight P((ExprPtr, double *, double *));
static int optmapaddcmp P((const void *, const void *));
static ExprPtr optimizePatMapAdd P((ExprPtr, double *, double *, ExprPtr));
static ExprPtr optimizePatRecMapAdd P((ExprPtr, double *, double *));
static ExprPtr optPatCouple P((ExprPtr, double *, double *, ExprKind, ExprKind));
static ExprPtr optPair P((ExprPtr, double *, double *));
static ExprPtr optimizePatternk P((ExprPtr, double *, double *));
static ExprPtr optimizePattern P((ExprPtr, double *, double *));
static permutationPtr nilPermutation P((void));
static int applyPermutation P((permutationPtr, int));
static void extendPermutation P((permutationPtr, int, int));
static ExprPtr renameVarref P((ExprPtr, permutationPtr, int, int));
static ExprPtr MakePatCheck P((ExprPtr, unsigned char *));
static ExprPtr renamePatternk P((ExprPtr, permutationPtr, int, int, int, ExprPtr));
static ExprPtr renamePattern P((ExprPtr, permutationPtr, int, int, int, ExprPtr));
static ExprPtr renameBindingsk P((ExprPtr, permutationPtr, int, int, int));
static ExprPtr renameBindings P((ExprPtr, permutationPtr, int, int, int));
static ExprPtr renameDomainsk P((ExprPtr, permutationPtr, int, int, int));
static ExprPtr renameDomains P((ExprPtr, permutationPtr, int, int, int));
static ExprPtr renameTuple P((ExprPtr, permutationPtr, int, int, int));
static ExprPtr renameExprk P((ExprPtr, permutationPtr, int, int, int));
static ExprPtr renameExpr P((ExprPtr, permutationPtr, int, int, int));
static Boolean sameBits P((register unsigned char *, register unsigned char *));
static ExprPtr getRecLabels P((ExprPtr, Boolean *));
static Boolean do_matchpatrecmapadd P((ExprPtr, ExprPtr, unsigned char *));
static Boolean matchPatRecMapAdd P((ExprPtr, ExprPtr, permutationPtr, long *));
static Boolean matchPatternk P((ExprPtr, ExprPtr, permutationPtr, long *));
static Boolean matchPattern P((ExprPtr, ExprPtr, permutationPtr, long *));
static ExprPtr reorderPatRecMapAdd P((ExprPtr, ExprPtr, ExprPtr, ExprPtr, long *));
static ExprPtr tackPatternk P((ExprPtr, ExprPtr, ExprPtr, ExprPtr, long *));
static Boolean do_tackdbgnames P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr unquoteData P((ExprPtr));
static Boolean hasChoice1 P((ExprPtr));
static ExprPtr getDbgNames1 P((ExprPtr, ExprPtr));
