/* static declarations for file debug.c */
static short opAt P((short *));
static ExprPtr getValue1 P((ExprPtr, struct snapshot *, ExprPtr *, ExprPtr));
static ExprPtr getValue P((ExprPtr, struct snapshot *, ExprPtr *));
static void initSnap P((struct snapshot *, byteCodeChunk *, ExprPtr *, Boolean));
static Boolean analyzeBc P((struct snapshot *, byteCodeChunk *, short *, ExprPtr *, Boolean, int *));
static Boolean analyzeBcs P((struct snapshot *, byteCodeChunk *, short *, ExprPtr *, struct bcframes *, struct bcstacks *, int));
static int nBcs P((struct bcframes *));
static void showVal1 P((ExprPtr, int));
static void showValNoType1 P((ExprPtr, int));
static void showVal P((ExprPtr, ExprPtr, int));
static void showSource P((ExprPtr, TZone *, hFILE *));
static ExprPtr getFileName P((ExprPtr, TZone *));
static void do_prtmax P((unsigned char *, int, char *));
static void showArgs P((struct snapshot *, int, Boolean, Boolean));
static void showStack P((byteCodeChunk *, short *, ExprPtr *, struct bcframes *, struct bcstacks *, int, int, int));
static int dgetc P((void));
static int skipLine P((void));
static int skipLinec P((int));
static int skipBlanks P((int));
static Boolean is_letter P((int));
static Boolean is_alpha P((int));
static Boolean is_symb P((int));
static Boolean is_filechar P((int));
static int skipWord P((void));
static int getInt P((int, int *, Boolean *));
static int getSignedInt P((int, int *, Boolean *));
static int getRealOrInt P((int, ExprPtr *, Boolean *));
static int getComplexOrInt P((int, ExprPtr *, Boolean *));
static int getStringCst P((int, ExprPtr *, Boolean *));
static int getId P((int, ExprPtr *, Boolean, Boolean));
static int getBasicValue P((int, ExprPtr *, Boolean *, Boolean));
static int getSelector P((int, ExprPtr *, Boolean *));
static int parseValue1 P((int, ExprPtr, ExprPtr *));
static int parseValue P((int, ExprPtr, ExprPtr *));
static int parseValueList P((int, ExprPtr *));
static ExprPtr dbgEvalRef P((ExprPtr, ExprPtr *));
static ExprPtr dbgEvalRefIter P((ExprPtr, ExprPtr *));
static ExprPtr dbgEval1 P((struct snapshot *, ExprPtr, ExprPtr *));
static ExprPtr dbgEval P((struct snapshot *, ExprPtr, ExprPtr *));
static void printDbgExpr1 P((hFILE *, ExprPtr));
static void printDbgExpr P((hFILE *, ExprPtr));
static void dbgView P((hFILE *, struct snapshot *, ExprPtr, Boolean, Boolean));
static Boolean do_printdebugvars P((ExprPtr, ExprPtr, unsigned char *));
static void printDebugVars P((void));
static Boolean do_possiblerefinements_record P((ExprPtr, ExprPtr, unsigned char *));
static void do_possiblerefinements_print P((unsigned char *, int, char *));
static Boolean do_possiblerefinements_map P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr possibleRefinements P((ExprPtr, ExprPtr, int, Boolean *));
static displayPossibleSelectors P((struct snapshot *, ExprPtr, int));
static ExprPtr addMonitorExprs P((ExprPtr, ExprPtr));
static ExprPtr delMonitorExprs P((ExprPtr, ExprPtr));
static void checkExceptions P((struct snapshot *, ExprPtr, Boolean, Boolean));
static void newBreaks P((struct breakpoints *));
static int findBreak P((register short *, struct breakpoints *));
static int addBreak P((byteCodeChunk *, short *, struct breakpoints *, Boolean));
static Boolean sweepBreaks1 P((ExprPtr, ExprPtr, long, byteCodeChunk *, sweepBreaksFun, char *, Boolean));
static Boolean sweepBreaks P((ExprPtr, ExprPtr, long, sweepBreaksFun, char *, Boolean));
static Boolean do_setbreak P((byteCodeChunk *, short *, char *));
static Boolean do_setbreak_on_entry P((byteCodeChunk *, short *, char *));
static int newBreak P((void));
static int setBreak P((ExprPtr, ExprPtr, long));
static int readLocation P((struct snapshot *, int, ExprPtr *, ExprPtr *, int *));
static void showBreak P((int));
static void eraseBreak P((int));
static Boolean installTmpBreaks P((struct bcframes *, byteCodeChunk *, int *, Boolean));
static void dbgError P((char *, int));
static void parseError P((int));
