/* static declarations for file typeaux.c */
static ExprPtr Cons P((ExprPtr, ExprPtr));
static ExprPtr freshInst P((ExprPtr, ExprPtr, ExprPtr, Boolean, ExprPtr *));
static Boolean do_newtypeinst P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_newtypeinst_num P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr newTyVarInst P((ExprPtr, ExprPtr, ExprPtr, Boolean, ExprPtr *));
static ExprPtr do_eqtypep P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr eqTypepK P((ExprPtr, ExprPtr, Boolean));
static Boolean do_imptypep P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_imptypep_num P((ExprPtr, ExprPtr, unsigned char *));
static Boolean impTypepk P((ExprPtr, ExprPtr));
static void nonNumError P((TZone *, ExprPtr, ExprPtr));
static ExprPtr do_typemul P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_typepower P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_occursp P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_occursp_num P((ExprPtr, ExprPtr, unsigned char *));
static Boolean occurspk P((ExprPtr, ExprPtr, ExprPtr));
static Boolean occursp P((ExprPtr, ExprPtr, ExprPtr));
static Boolean do_eqimptype P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_eqimptype_num P((ExprPtr, ExprPtr, unsigned char *));
static Boolean eqimpTypek P((int, ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static Boolean eqimpType P((int, ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static void setFailure P((int, ExprPtr, ExprPtr));
static Boolean unify_var P((ExprPtr, ExprPtr, ExprPtr, ExprPtr, Boolean));
static Boolean unify_list P((ExprPtr, ExprPtr, ExprPtr, ExprPtr, Boolean));
static ExprPtr do_instnumtype P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_unify_num P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr mininv P((ExprPtr));
static Boolean unify_num P((ExprPtr, ExprPtr, ExprPtr, ExprPtr, Boolean));
static ExprPtr get_real_map_type P((ExprPtr, ExprPtr, ExprPtr, ExprPtr *, Boolean));
static ExprPtr addMapRest P((ExprPtr, ExprPtr));
static Boolean do_unify_map P((ExprPtr, ExprPtr, unsigned char *));
static Boolean unify_map P((ExprPtr, ExprPtr, ExprPtr, ExprPtr, Boolean));
static Boolean unify11 P((ExprPtr, ExprPtr, ExprPtr, ExprPtr, Boolean));
static Boolean unify P((ExprPtr, ExprPtr, ExprPtr, ExprPtr, Boolean));
static void explainDifFunc P((ExprPtr, ExprPtr));
static void explainDifSorts P((ExprPtr, ExprPtr, ExprPtr));
static void explainBindGen P((ExprPtr, ExprPtr));
static void explainOccurs P((ExprPtr, ExprPtr, ExprPtr));
static Boolean do_explainmisslbls P((ExprPtr, ExprPtr, unsigned char *));
static void explainMissLbls P((ExprPtr, ExprPtr, ExprPtr));
static void explainDifTags P((ExprPtr, ExprPtr, ExprPtr));
static void explainDif P((ExprPtr, ExprPtr));
static ExprPtr freshTyVar P((ExprPtr, int *, int));
static void getTyHdrSubsts1 P((ExprPtr, ExprPtr, ExprPtr, ExprPtr, ExprPtr *, ExprPtr *, ExprPtr, int *, ExprPtr));
static Boolean do_mergerecordtypes P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr mergeRecordTypes P((TZone *, ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static Boolean do_typesubst P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr typeSubstTuple P((TZone *, ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr typeSubstNum P((TZone *, ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr typeSubstk P((TZone *, ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr InitTypeRename P((ExprPtr, Boolean));
static void ResetTypeRename P((ExprPtr, ExprPtr));
static ExprPtr tyvarRename P((ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static Boolean do_dump_rectype P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr fieldsToRecType P((int, field *));
static ExprPtr recTypeRename P((ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static int cmpnum P((const void *, const void *));
static ExprPtr numTypeRename P((ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr do_typerenamemap_0 P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr TypeRenamek P((ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static ExprPtr TypeRename1 P((ExprPtr, ExprPtr, ExprPtr, ExprPtr));
static Boolean do_pack_check P((ExprPtr, char *));
static void pack_check P((ExprPtr, ExprPtr));
static ExprPtr do_insttyfcn P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_killnongens P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_renamelist P((ExprPtr, char *));
static void renameList P((ExprPtr, struct typerenamemap *));
static ExprPtr do_insttyvarsubs P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_respectseq P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_initmaxeq P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_geteq P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_truesubst P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_repleq P((ExprPtr, ExprPtr, unsigned char *));
static Boolean do_checkeqconds P((ExprPtr, ExprPtr, unsigned char *));
static void checkEqConds P((ExprPtr, ExprPtr, ExprPtr, ExprPtr, TZone *));
static ExprPtr freshTyName1 P((unsigned char *, long, ExprPtr, ExprPtr, unsigned long));
static ExprPtr concTyName P((ExprPtr, unsigned char *));
static ExprPtr do_initabseq P((ExprPtr, ExprPtr, unsigned char *));
static void warnGen P((TZone *, ExprPtr));
static Boolean do_checkexplicits P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_tyvars P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_tyvars_num P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_unquant_y P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_unquant_x P((ExprPtr, ExprPtr, unsigned char *));
static ExprPtr do_unquant_packers P((ExprPtr, char *));
static Boolean do_instscale P((ExprPtr, ExprPtr, unsigned char *));
